#include "stdafx.h"
#include "main.h"

#include "sys/sys.h"

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
		break;

	case DLL_PROCESS_DETACH:
	case DLL_THREAD_DETACH:
		break;
	}
    return TRUE;
}

#include "main_register.inl"

void sampOnLoad(void)
{
	sys::gMySQL.Connect("localhost", 3306, "samp", "cocacola997");
	sys::gMySQL.SelectDB("samp");

	test_mysql();

	sampSetGameModeText("cppwrapper");

	//sampUsePlayerPedAnims();
	sampEnableTirePopping(true);
	sampEnableZoneNames(false);

	sampSendClientMessageToAll(0xff0000ff, "*** Gamemode loaded (Gamemode )");

	//Note: Due to the architectire of the system, there can be online players when
	//sampOnLoad() is called, which have already connected, selected their class
	//and walked somewhere. Take actions...
}

void sampOnUnload(void)
{
	sys::MySQL().Close();

	sampSendClientMessageToAll(0xff0000ff, "*** Gamemode unloaded (Gamemode )");
}

int sampOnTimer100(void)
{
	static int count = 0;
	static int zoneid = -1;

	//sampShowNameTags(false);
	//sampShowPlayerMarkers(false);

	if(count % 30 == 0)//check only once per 3 seconds
	if(sampIsPlayerConnected(0))
	{
		float cc[3] = { -1636.0f, -240.0f, 15.0f };
		float c[3];
		float sqrs[3];
		
		sampGetPlayerPos(0, c[0], c[1], c[2]);

		sqrs[0] = c[0] - cc[0];
		sqrs[1] = c[1] - cc[1];
		sqrs[2] = c[2] - cc[2];

		sqrs[0] *= sqrs[0];
		sqrs[1] *= sqrs[1];
		sqrs[2] *= sqrs[2];
		if( sqrs[0] + sqrs[1] + sqrs[2] < 100.0f)
		{
			sampCreateExplosion(c[0], c[1], c[2], 6, 10.0f);
			//sampSetPlayerPos(0, -1650.0, -240.0, 15.0);
		}

		char name[32];
		sampGetPlayerName(0, name, sizeof(name));

		char msg[512];
		sprintf_s(msg, sizeof(msg), " , %s!   - %.3f %.3f %.3f", name, c[0], c[1], c[2]);
		//sampSendClientMessage(0, 0xff0000ff, msg);
	}

	count++;
	if(count >= 1115464350)
		count = 0;

	return 0;
}

//-int sampOnFilterScriptExit();
//-int sampOnFilterScriptInit();

//-int sampOnGameModeExit();
//-int sampOnGameModeInit();

int sampOnObjectMoved(int objectid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnObjectMoved(%d)", objectid);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerCommandText(int playerid, const char *cmdtext)
{
	string text(cmdtext), cmd, arg;
	size_t len = text.length();
	vector<string> args;
	size_t i1, i2;
	i1 = text.find(' ');
	cmd = text.substr(0, i1);

	while(i1 != string::npos)
	{
		//skip spaces
		if(i1 < len - 1)
		{
			i1++;

			if(text.at(i1) == ' ')
				continue;
		}
		else
			break;

		i2 = text.find(' ', i1);//note: text[i1] is not a ' '
		arg = text.substr(i1, i2 == string::npos ? len - i1 : i2 - i1);
		args.push_back(arg);
		i1 = i2;
	}

	//got `cmd` and `args` here

	string msg = "Command parsed: ";
	msg += "{";	msg += cmd;	msg += "} ";

	for(vector<string>::iterator it = args.begin(); it != args.end(); it++)
	{
		msg += "["; msg += *it; msg += "] ";
	}

	if(cmd == "/money")
	{
		if(args.size() != 1)
		{
			sampSendClientMessage(playerid, 0xff0000ff, "* /money [amount] to give yourself money");
			return 1;
		}

		sampGivePlayerMoney(playerid, atol(args[0].c_str()));
		return 1;
	}
	else if(cmd == "/v")
	{
		if(args.size() != 1)
		{
			sampSendClientMessage(playerid, 0xff0000ff, "* /v [id] to create a vehicle");
			return 1;
		}

		float x, y, z;
		sampGetPlayerPos(playerid, x, y, z);
		sampCreateVehicle(atol(args[0].c_str()), x + 10.0f, y, z, 0.0, -1, -1, 600);

		return 1;
	}
	else if(cmd == "/vcomp")
	{
		if(args.size() != 1)
		{
			sampSendClientMessage(playerid, 0xff0000ff, "* /vcomp [id] to add a component to your vehicle");
			return 1;
		}

		if(sampIsPlayerInAnyVehicle(playerid))
		{
			int v_id = sampGetPlayerVehicleID(playerid);
			sampAddVehicleComponent(v_id, atol(args[0].c_str()));
		}
		else
			sampSendClientMessage(playerid, 0xff0000ff, "* You're not in vehicle");

		return 1;
	}

	sampSendClientMessage(playerid, 0x00ff00ff, msg.c_str());

	return 1;
}

int sampOnPlayerConnect(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerConnect(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerDeath(int playerid, int killerid, int reason)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerDeath(%d, %d, %d)", playerid, killerid, reason);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerDisconnect(int playerid, int reason)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerDisconnect(%d, %d)", playerid, reason);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerEnterCheckpoint(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerEnterCheckpoint(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerEnterRaceCheckpoint(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerEnterRaceCheckpoint(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerEnterVehicle(int playerid, int vehicleid, int ispassenger)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerEnterVehicle(%d, %d, %d)", playerid, vehicleid, ispassenger);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerExitedMenu(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerExitedMenu(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerExitVehicle(int playerid, int vehicleid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerExitVehicle(%d, %d)", playerid, vehicleid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerInfoChange(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerInfoChange(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerInteriorChange(int playerid, int newinteriorid, int oldinteriorid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerInteriorChange(%d, %d, %d)", playerid, newinteriorid, oldinteriorid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerKeyStateChange(int playerid, int newkeys, int oldkeys)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerKeyStateChange(%d, %d, %d)", playerid, newkeys, oldkeys);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerLeaveCheckpoint(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerLeaveCheckpoint(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerLeaveRaceCheckpoint(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerLeaveRaceCheckpoint(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerObjectMoved(int playerid, int objectid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerObjectMoved(%d, %d)", playerid, objectid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerPickUpPickup(int playerid, int pickupid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerPickUpPickup(%d, %d)", playerid, pickupid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerPrivmsg(int playerid, int recieverid, const char *text)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerPrivmsg(%d, %d, %s)", playerid, recieverid, text);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerRequestClass(int playerid, int classid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerRequestClass(%d, %d)", playerid, classid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerRequestSpawn(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerRequestSpawn(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 1;
}

int sampOnPlayerSelectedMenuRow(int playerid, int row)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerSelectedMenuRow(%d, %d)", playerid, row);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerSpawn(int playerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerSpawn(%d)", playerid);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	sampSetPlayerPos(playerid, -1655.0, -249.0, 15.0); //airport of city 2
	//sampSetPlayerPos(playerid, -100.0, 2500.0, 20.0); //abandoned airport

	return 1;
}

int sampOnPlayerStateChange(int playerid, int newstate, int oldstate)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnPlayerStateChange(%d, %d, %d)", playerid, newstate, oldstate);
	sampSendClientMessage(playerid, 0x00dd00ff, msg);

	return 0;
}

int sampOnPlayerText(int playerid, const char *text)
{
	if(text[0] != 0 && (text[0] == '\\' || text[0] == '!' || text[0] == '?' || text[0] == '+' || text[0] == '-'))
	{
		sampOnPlayerCommandText(playerid, text);
		return 0;
	}

	return 1;
}

int sampOnRconCommand(const char *cmd)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnRconCommand(%s)", msg);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}

int sampOnVehicleDeath(int vehicleid, int killerid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnVehicleDeath(%d, %d)", vehicleid, killerid);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}

int sampOnVehicleMod(int vehicleid, int componentid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnVehicleMod(%d, %d)", vehicleid, vehicleid);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}

int sampOnVehiclePaintjob(int vehicleid, int paintjobid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnVehiclePaintjob(%d, %d)", vehicleid, vehicleid);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}

int sampOnVehicleRespray(int vehicleid, int color1, int color2)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnVehicleRespray(%d, %d)", vehicleid, vehicleid);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}

int sampOnVehicleSpawn(int vehicleid)
{
	char msg[256];
	sprintf_s(msg, 256, "sampOnVehicleSpawn(%d)", vehicleid);
	sampSendClientMessageToAll(0x00dd00ff, msg);

	return 0;
}
