#include "stdafx.h"

typedef struct
{
	string name;
	void *func;
} SNamedFunction;

void *__sampFindNamedFunction(const vector<SNamedFunction> &funcs, const string &name);

__declspec(dllexport)
void WrapperRegister(const vector<SNamedFunction> amx_funcs, vector<SNamedFunction> &callback_funcs);

// -- List of samp functions --

typedef void (*t_sampAddPlayerClass)(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo);
typedef void (*t_sampAllowAdminTeleport)(bool allow);
typedef void (*t_sampAllowInteriorWeapons)(bool allow);
typedef void (*t_sampBan)(int playerid);
typedef void (*t_sampBanEx)(int playerid, const char *reason);
typedef void (*t_sampCreateExplosion)(float X, float Y, float Z, int type, float Radius);
typedef int (*t_sampCreatePickup)(int model, int type, float X, float Y, float Z);
typedef void (*t_sampDestroyPickup)(int pickup);
typedef void (*t_sampEnableTirePopping)(bool enable);
typedef void (*t_sampEnableZoneNames)(bool enable);
typedef void (*t_sampGameTextForAll)(const char *string, int time, int style);
typedef void (*t_sampGameTextForPlayer)(int playerid, const char *string, int time, int style);
typedef int (*t_sampGangZoneCreate)(float minx, float miny, float maxx, float maxy);
typedef void (*t_sampGangZoneDestroy)(int zone);
typedef void (*t_sampGangZoneFlashForAll)(int zone, unsigned long flashcolor);
typedef void (*t_sampGangZoneFlashForPlayer)(int playerid, int zone, unsigned long flashcolor);
typedef void (*t_sampGangZoneHideForAll)(int zone);
typedef void (*t_sampGangZoneHideForPlayer)(int playerid, int zone);
typedef void (*t_sampGangZoneShowForAll)(int zone, unsigned long color);
typedef void (*t_sampGangZoneShowForPlayer)(int playerid, int zone, unsigned long color);
typedef void (*t_sampGangZoneStopFlashForAll)(int zone);
typedef void (*t_sampGangZoneStopFlashForPlayer)(int playerid, int zone);
typedef int (*t_sampIsPlayerAdmin)(int playerid);
typedef void (*t_sampKick)(int playerid);
typedef void (*t_sampLimitGlobalChatRadius)(float chat_radius);
typedef void (*t_sampSendClientMessage)(int playerid, unsigned long color, const char *message);
typedef void (*t_sampSendClientMessageToAll)(unsigned long color, const char *message);
typedef void (*t_sampSendDeathMessage)(int killer, int killee, int weapon);
typedef void (*t_sampSendPlayerMessageToAll)(int senderid, const char *message);
typedef void (*t_sampSendPlayerMessageToPlayer)(int playerid, int senderid, const char *message);
typedef void (*t_sampSetGameModeText)(const char *string);
typedef void (*t_sampSetGravity)(float gravity);
typedef void (*t_sampSetWeather)(int weatherid);
typedef void (*t_sampSetWorldTime)(int hour);
typedef void (*t_sampShowNameTags)(bool show);
typedef void (*t_sampShowPlayerMarkers)(bool show);
typedef void (*t_sampUsePlayerPedAnims)();		

typedef void (*t_sampAllowPlayerTeleport)(int playerid, bool allow);
typedef void (*t_sampApplyAnimation)(int playerid, const char *animlib, const char *animname, float fS, int opt1, int opt2, int opt3, int opt4, int opt5);
typedef void (*t_sampClearAnimations)(int playerid);
typedef void (*t_sampDisablePlayerCheckpoint)(int playerid);
typedef void (*t_sampDisablePlayerRaceCheckpoint)(int playerid);
typedef void (*t_sampForceClassSelection)(int playerid);
typedef int (*t_sampGetPlayerAmmo)(int playerid);
typedef void (*t_sampGetPlayerArmour)(int playerid, float &armour);
typedef unsigned long (*t_sampGetPlayerColor)(int playerid);
typedef void (*t_sampGetPlayerFacingAngle)(int playerid, float &ang);
typedef void (*t_sampGetPlayerHealth)(int playerid, float &health);
typedef int (*t_sampGetPlayerInterior)(int playerid);
typedef void (*t_sampGetPlayerIp)(int playerid, char *name, int len);
typedef void (*t_sampGetPlayerKeys)(int playerid, unsigned long &keys, unsigned long &updown, unsigned long &leftright);
typedef int (*t_sampGetPlayerMoney)(int playerid);
typedef void (*t_sampGetPlayerName)(int playerid, char *name, int len);
typedef int (*t_sampGetPlayerPing)(int playerid);
typedef void (*t_sampGetPlayerPos)(int playerid, float &x, float &y, float &z);
typedef int (*t_sampGetPlayerScore)(int playerid);
typedef int (*t_sampGetPlayerSkin)(int playerid);
typedef int (*t_sampGetPlayerSpecialAction)(int playerid);
typedef int (*t_sampGetPlayerState)(int playerid);
typedef int (*t_sampGetPlayerTeam)(int playerid);
typedef void (*t_sampGetPlayerTime)(int playerid, int &hour, int &minute);
typedef int (*t_sampGetPlayerVehicleID)(int playerid);
typedef int (*t_sampGetPlayerVirtualWorld)(int playerid);
typedef int (*t_sampGetPlayerWantedLevel)(int playerid);
typedef int (*t_sampGetPlayerWeapon)(int playerid);
typedef void (*t_sampGetPlayerWeaponData)(int playerid, int slot, int &weapon, int &ammo);
typedef void (*t_sampGivePlayerMoney)(int playerid, int money);
typedef void (*t_sampGivePlayerWeapon)(int playerid, int weaponid, int ammo);
typedef int (*t_sampIsPlayerConnected)(int playerid);
typedef int (*t_sampIsPlayerInAnyVehicle)(int playerid);
typedef int (*t_sampIsPlayerInCheckpoint)(int playerid);
typedef int (*t_sampIsPlayerInRaceCheckpoint)(int playerid);
typedef int (*t_sampIsPlayerInVehicle)(int playerid, int vehicleid);
typedef void (*t_sampPlayerPlaySound)(int playerid, int soundid, float x, float y, float z);
typedef void (*t_sampPlayerSpectatePlayer)(int playerid, int targetplayerid, int mode);
typedef void (*t_sampPlayerSpectateVehicle)(int playerid, int targetvehicleid, int mode);
typedef void (*t_sampPutPlayerInVehicle)(int playerid, int vehicleid, int seatid);
typedef void (*t_sampRemovePlayerFromVehicle)(int playerid);
typedef void (*t_sampRemovePlayerMapIcon)(int playerid, int iconid);
typedef void (*t_sampResetPlayerMoney)(int playerid);
typedef void (*t_sampResetPlayerWeapons)(int playerid);
typedef void (*t_sampSetCameraBehindPlayer)(int playerid);
typedef void (*t_sampSetPlayerAmmo)(int playerid, int weaponslot, int ammo);
typedef void (*t_sampSetPlayerArmour)(int playerid, float armour);
typedef void (*t_sampSetPlayerCameraLookAt)(int playerid, float x, float y, float z);
typedef void (*t_sampSetPlayerCameraPos)(int playerid, float x, float y, float z);
typedef void (*t_sampSetPlayerCheckpoint)(int playerid, float x, float y, float z, float size);
typedef void (*t_sampSetPlayerColor)(int playerid, unsigned long color);
typedef void (*t_sampSetPlayerFacingAngle)(int playerid, float ang);
typedef void (*t_sampSetPlayerHealth)(int playerid, float health);
typedef void (*t_sampSetPlayerInterior)(int playerid, int interiorid);
typedef int (*t_sampSetPlayerMapIcon)(int playerid, int iconid, float x, float y, float z, int markertype, unsigned long color);
typedef void (*t_sampSetPlayerMarkerForPlayer)(int playerid, int showplayerid, unsigned long color);
typedef void (*t_sampSetPlayerName)(int playerid, const char *name);
typedef void (*t_sampSetPlayerPos)(int playerid, float x, float y, float z);
typedef void (*t_sampSetPlayerPosFindZ)(int playerid, float x, float y, float z);
typedef void (*t_sampSetPlayerRaceCheckpoint)(int playerid, int type, float x, float y, float z, float nextx, float nexty, float nextz, float size);
typedef void (*t_sampSetPlayerScore)(int playerid, int score);
typedef void (*t_sampSetPlayerSkin)(int playerid, int skinid);
typedef void (*t_sampSetPlayerSpecialAction)(int playerid, int actionid);
typedef void (*t_sampSetPlayerTeam)(int playerid, int teamid);
typedef void (*t_sampSetPlayerTime)(int playerid, int hour, int minute);
typedef void (*t_sampSetPlayerVirtualWorld)(int playerid, int worldid);
typedef void (*t_sampSetPlayerWantedLevel)(int playerid, int level);
typedef void (*t_sampSetPlayerWeather)(int playerid, int weather);
typedef void (*t_sampSetPlayerWorldBounds)(int playerid, float x_max, float x_min, float y_max, float y_min);
typedef void (*t_sampSetSpawnInfo)(int playerid, int team, int skin, float x, float y, float z, float rotation, int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo);
typedef void (*t_sampShowPlayerNameTagForPlayer)(int playerid, int showplayerid, bool show);
typedef void (*t_sampSpawnPlayer)(int playerid);
typedef void (*t_sampTogglePlayerClock)(int playerid, bool toggle);
typedef void (*t_sampTogglePlayerControllable)(int playerid, bool toggle);
typedef void (*t_sampTogglePlayerSpectating)(int playerid, bool toggle);

typedef void (*t_sampAddVehicleComponent)(int vehicleid, int componentid);
typedef void (*t_sampAttachTrailerToVehicle)(int trailerid, int vehicleid);
typedef void (*t_sampChangeVehicleColor)(int vehicleid, unsigned long color1, unsigned long color2);
typedef void (*t_sampChangeVehiclePaintjob)(int vehicleid, int paintjobid);
typedef int (*t_sampCreateVehicle)(int vehicletype, float x, float y, float z, float rotation, unsigned long color1, unsigned long color2, int respawn_delay);
typedef void (*t_sampDestroyVehicle)(int vehicleid);
typedef void (*t_sampDetachTrailerFromVehicle)(int vehicleid);
typedef void (*t_sampGetVehicleHealth)(int vehicleid, float &health);
typedef int (*t_sampGetVehicleModel)(int vehicleid);
typedef void (*t_sampGetVehiclePos)(int vehicleid, float &x, float &y, float &z);
typedef int (*t_sampGetVehicleTrailer)(int vehicleid);
typedef int (*t_sampGetVehicleVirtualWorld)(int vehicleid);
typedef void (*t_sampGetVehicleZAngle)(int vehicleid, float &z_angle);
typedef int (*t_sampIsTrailerAttachedToVehicle)(int vehicleid);
typedef void (*t_sampLinkVehicleToInterior)(int vehicleid, int interiorid);
typedef void (*t_sampRemoveVehicleComponent)(int vehicleid, int componentid);
typedef void (*t_sampSetVehicleHealth)(int vehicleid, float health);
typedef void (*t_sampSetVehicleNumberPlate)(int vehicleid, const char *numberplate);
typedef void (*t_sampSetVehicleParamsForPlayer)(int vehicleid, int playerid, bool objective, bool doorslocked);
typedef void (*t_sampSetVehiclePos)(int vehicleid, float x, float y, float z);
typedef void (*t_sampSetVehicleToRespawn)(int vehicleid);
typedef void (*t_sampSetVehicleVirtualWorld)(int vehicleid, int worldid);
typedef void (*t_sampSetVehicleZAngle)(int vehicleid, float z_angle);

t_sampAddPlayerClass sampAddPlayerClass = NULL;
t_sampAllowAdminTeleport sampAllowAdminTeleport = NULL;
t_sampAllowInteriorWeapons sampAllowInteriorWeapons = NULL;
t_sampBan sampBan = NULL;
t_sampBanEx sampBanEx = NULL;
t_sampCreateExplosion sampCreateExplosion = NULL;
t_sampCreatePickup sampCreatePickup = NULL;
t_sampDestroyPickup sampDestroyPickup = NULL;
t_sampEnableTirePopping sampEnableTirePopping = NULL;
t_sampEnableZoneNames sampEnableZoneNames = NULL;
t_sampGameTextForAll sampGameTextForAll = NULL;
t_sampGameTextForPlayer sampGameTextForPlayer = NULL;
t_sampGangZoneCreate sampGangZoneCreate = NULL;
t_sampGangZoneDestroy sampGangZoneDestroy = NULL;
t_sampGangZoneFlashForAll sampGangZoneFlashForAll = NULL;
t_sampGangZoneFlashForPlayer sampGangZoneFlashForPlayer = NULL;
t_sampGangZoneHideForAll sampGangZoneHideForAll = NULL;
t_sampGangZoneHideForPlayer sampGangZoneHideForPlayer = NULL;
t_sampGangZoneShowForAll sampGangZoneShowForAll = NULL;
t_sampGangZoneShowForPlayer sampGangZoneShowForPlayer = NULL;
t_sampGangZoneStopFlashForAll sampGangZoneStopFlashForAll = NULL;
t_sampGangZoneStopFlashForPlayer sampGangZoneStopFlashForPlayer = NULL;
t_sampIsPlayerAdmin sampIsPlayerAdmin = NULL;
t_sampKick sampKick = NULL;
t_sampLimitGlobalChatRadius sampLimitGlobalChatRadius = NULL;
t_sampSendClientMessage sampSendClientMessage = NULL;
t_sampSendClientMessageToAll sampSendClientMessageToAll = NULL;
t_sampSendDeathMessage sampSendDeathMessage = NULL;
t_sampSendPlayerMessageToAll sampSendPlayerMessageToAll = NULL;
t_sampSendPlayerMessageToPlayer sampSendPlayerMessageToPlayer = NULL;
t_sampSetGameModeText sampSetGameModeText = NULL;
t_sampSetGravity sampSetGravity = NULL;
t_sampSetWeather sampSetWeather = NULL;
t_sampSetWorldTime sampSetWorldTime = NULL;
t_sampShowNameTags sampShowNameTags = NULL;
t_sampShowPlayerMarkers sampShowPlayerMarkers = NULL;
t_sampUsePlayerPedAnims sampUsePlayerPedAnims = NULL;		

t_sampAllowPlayerTeleport sampAllowPlayerTeleport = NULL;
t_sampApplyAnimation sampApplyAnimation = NULL;
t_sampClearAnimations sampClearAnimations = NULL;
t_sampDisablePlayerCheckpoint sampDisablePlayerCheckpoint = NULL;
t_sampDisablePlayerRaceCheckpoint sampDisablePlayerRaceCheckpoint = NULL;
t_sampForceClassSelection sampForceClassSelection = NULL;
t_sampGetPlayerAmmo sampGetPlayerAmmo = NULL;
t_sampGetPlayerArmour sampGetPlayerArmour = NULL;
t_sampGetPlayerColor sampGetPlayerColor = NULL;
t_sampGetPlayerFacingAngle sampGetPlayerFacingAngle = NULL;
t_sampGetPlayerHealth sampGetPlayerHealth = NULL;
t_sampGetPlayerInterior sampGetPlayerInterior = NULL;
t_sampGetPlayerIp sampGetPlayerIp = NULL;
t_sampGetPlayerKeys sampGetPlayerKeys = NULL;
t_sampGetPlayerMoney sampGetPlayerMoney = NULL;
t_sampGetPlayerName sampGetPlayerName = NULL;
t_sampGetPlayerPing sampGetPlayerPing = NULL;
t_sampGetPlayerPos sampGetPlayerPos = NULL;
t_sampGetPlayerScore sampGetPlayerScore = NULL;
t_sampGetPlayerSkin sampGetPlayerSkin = NULL;
t_sampGetPlayerSpecialAction sampGetPlayerSpecialAction = NULL;
t_sampGetPlayerState sampGetPlayerState = NULL;
t_sampGetPlayerTeam sampGetPlayerTeam = NULL;
t_sampGetPlayerTime sampGetPlayerTime = NULL;
t_sampGetPlayerVehicleID sampGetPlayerVehicleID = NULL;
t_sampGetPlayerVirtualWorld sampGetPlayerVirtualWorld = NULL;
t_sampGetPlayerWantedLevel sampGetPlayerWantedLevel = NULL;
t_sampGetPlayerWeapon sampGetPlayerWeapon = NULL;
t_sampGetPlayerWeaponData sampGetPlayerWeaponData = NULL;
t_sampGivePlayerMoney sampGivePlayerMoney = NULL;
t_sampGivePlayerWeapon sampGivePlayerWeapon = NULL;
t_sampIsPlayerConnected sampIsPlayerConnected = NULL;
t_sampIsPlayerInAnyVehicle sampIsPlayerInAnyVehicle = NULL;
t_sampIsPlayerInCheckpoint sampIsPlayerInCheckpoint = NULL;
t_sampIsPlayerInRaceCheckpoint sampIsPlayerInRaceCheckpoint = NULL;
t_sampIsPlayerInVehicle sampIsPlayerInVehicle = NULL;
t_sampPlayerPlaySound sampPlayerPlaySound = NULL;
t_sampPlayerSpectatePlayer sampPlayerSpectatePlayer = NULL;
t_sampPlayerSpectateVehicle sampPlayerSpectateVehicle = NULL;
t_sampPutPlayerInVehicle sampPutPlayerInVehicle = NULL;
t_sampRemovePlayerFromVehicle sampRemovePlayerFromVehicle = NULL;
t_sampRemovePlayerMapIcon sampRemovePlayerMapIcon = NULL;
t_sampResetPlayerMoney sampResetPlayerMoney = NULL;
t_sampResetPlayerWeapons sampResetPlayerWeapons = NULL;
t_sampSetCameraBehindPlayer sampSetCameraBehindPlayer = NULL;
t_sampSetPlayerAmmo sampSetPlayerAmmo = NULL;
t_sampSetPlayerArmour sampSetPlayerArmour = NULL;
t_sampSetPlayerCameraLookAt sampSetPlayerCameraLookAt = NULL;
t_sampSetPlayerCameraPos sampSetPlayerCameraPos = NULL;
t_sampSetPlayerCheckpoint sampSetPlayerCheckpoint = NULL;
t_sampSetPlayerColor sampSetPlayerColor = NULL;
t_sampSetPlayerFacingAngle sampSetPlayerFacingAngle = NULL;
t_sampSetPlayerHealth sampSetPlayerHealth = NULL;
t_sampSetPlayerInterior sampSetPlayerInterior = NULL;
t_sampSetPlayerMapIcon sampSetPlayerMapIcon = NULL;
t_sampSetPlayerMarkerForPlayer sampSetPlayerMarkerForPlayer = NULL;
t_sampSetPlayerName sampSetPlayerName = NULL;
t_sampSetPlayerPos sampSetPlayerPos = NULL;
t_sampSetPlayerPosFindZ sampSetPlayerPosFindZ = NULL;
t_sampSetPlayerRaceCheckpoint sampSetPlayerRaceCheckpoint = NULL;
t_sampSetPlayerScore sampSetPlayerScore = NULL;
t_sampSetPlayerSkin sampSetPlayerSkin = NULL;
t_sampSetPlayerSpecialAction sampSetPlayerSpecialAction = NULL;
t_sampSetPlayerTeam sampSetPlayerTeam = NULL;
t_sampSetPlayerTime sampSetPlayerTime = NULL;
t_sampSetPlayerVirtualWorld sampSetPlayerVirtualWorld = NULL;
t_sampSetPlayerWantedLevel sampSetPlayerWantedLevel = NULL;
t_sampSetPlayerWeather sampSetPlayerWeather = NULL;
t_sampSetPlayerWorldBounds sampSetPlayerWorldBounds = NULL;
t_sampSetSpawnInfo sampSetSpawnInfo = NULL;
t_sampShowPlayerNameTagForPlayer sampShowPlayerNameTagForPlayer = NULL;
t_sampSpawnPlayer sampSpawnPlayer = NULL;
t_sampTogglePlayerClock sampTogglePlayerClock = NULL;
t_sampTogglePlayerControllable sampTogglePlayerControllable = NULL;
t_sampTogglePlayerSpectating sampTogglePlayerSpectating = NULL;

t_sampAddVehicleComponent sampAddVehicleComponent = NULL;
t_sampAttachTrailerToVehicle sampAttachTrailerToVehicle = NULL;
t_sampChangeVehicleColor sampChangeVehicleColor = NULL;
t_sampChangeVehiclePaintjob sampChangeVehiclePaintjob = NULL;
t_sampCreateVehicle sampCreateVehicle = NULL;
t_sampDestroyVehicle sampDestroyVehicle = NULL;
t_sampDetachTrailerFromVehicle sampDetachTrailerFromVehicle = NULL;
t_sampGetVehicleHealth sampGetVehicleHealth = NULL;
t_sampGetVehicleModel sampGetVehicleModel = NULL;
t_sampGetVehiclePos sampGetVehiclePos = NULL;
t_sampGetVehicleTrailer sampGetVehicleTrailer = NULL;
t_sampGetVehicleVirtualWorld sampGetVehicleVirtualWorld = NULL;
t_sampGetVehicleZAngle sampGetVehicleZAngle = NULL;
t_sampIsTrailerAttachedToVehicle sampIsTrailerAttachedToVehicle = NULL;
t_sampLinkVehicleToInterior sampLinkVehicleToInterior = NULL;
t_sampRemoveVehicleComponent sampRemoveVehicleComponent = NULL;
t_sampSetVehicleHealth sampSetVehicleHealth = NULL;
t_sampSetVehicleNumberPlate sampSetVehicleNumberPlate = NULL;
t_sampSetVehicleParamsForPlayer sampSetVehicleParamsForPlayer = NULL;
t_sampSetVehiclePos sampSetVehiclePos = NULL;
t_sampSetVehicleToRespawn sampSetVehicleToRespawn = NULL;
t_sampSetVehicleVirtualWorld sampSetVehicleVirtualWorld = NULL;
t_sampSetVehicleZAngle sampSetVehicleZAngle = NULL;

//Not callbacks. Are called from DllMain().
void sampOnLoad(void);
void sampOnUnload(void);

//One special callback. Called every 100ms from pwn, by default.
int sampOnTimer100(void);

//-int sampOnFilterScriptExit();
//-int sampOnFilterScriptInit();
//-int sampOnGameModeExit(void);
//-int sampOnGameModeInit(void);

int sampOnObjectMoved(int objectid);
int sampOnPlayerCommandText(int playerid, const char *cmdtext);
int sampOnPlayerConnect(int playerid);
int sampOnPlayerDeath(int playerid, int killerid, int reason);
int sampOnPlayerDisconnect(int playerid, int reason);
int sampOnPlayerEnterCheckpoint(int playerid);
int sampOnPlayerEnterRaceCheckpoint(int playerid);
int sampOnPlayerEnterVehicle(int playerid, int vehicleid, int ispassenger);
int sampOnPlayerExitedMenu(int playerid);
int sampOnPlayerExitVehicle(int playerid, int vehicleid);
int sampOnPlayerInfoChange(int playerid);
int sampOnPlayerInteriorChange(int playerid, int newinteriorid, int oldinteriorid);
int sampOnPlayerKeyStateChange(int playerid, int newkeys, int oldkeys);
int sampOnPlayerLeaveCheckpoint(int playerid);
int sampOnPlayerLeaveRaceCheckpoint(int playerid);
int sampOnPlayerObjectMoved(int playerid, int objectid);
int sampOnPlayerPickUpPickup(int playerid, int pickupid);
int sampOnPlayerPrivmsg(int playerid, int recieverid, const char *text);
int sampOnPlayerRequestClass(int playerid, int classid);
int sampOnPlayerRequestSpawn(int playerid);
int sampOnPlayerSelectedMenuRow(int playerid, int row);
int sampOnPlayerSpawn(int playerid);
int sampOnPlayerStateChange(int playerid, int newstate, int oldstate);
int sampOnPlayerText(int playerid, const char *text);
int sampOnRconCommand(const char *cmd);
int sampOnVehicleDeath(int vehicleid, int killerid);
int sampOnVehicleMod(int vehicleid, int componentid);
int sampOnVehiclePaintjob(int vehicleid, int paintjobid);
int sampOnVehicleRespray(int vehicleid, int color1, int color2);
int sampOnVehicleSpawn(int vehicleid);
