void *__sampFindNamedFunction(const vector<SNamedFunction> &funcs, const string &name)
{
	for(size_t i = 0; i < funcs.size(); i++)
	{
		if(funcs[i].name == name)
			return funcs[i].func;
	}

	string msg = "Unable to find amx function:\r\n";
	msg += name;
	MessageBoxA(0, msg.c_str(), "Error", 0);

	return NULL;
}

__declspec(dllexport)
void WrapperRegister(const vector<SNamedFunction> amx_funcs, vector<SNamedFunction> &callback_funcs)
{
	SNamedFunction f;

	f.name = "sampOnLoad";
	f.func = sampOnLoad;
	callback_funcs.push_back(f);

	f.name = "sampOnUnload";
	f.func = sampOnUnload;
	callback_funcs.push_back(f);

	f.name = "sampOnTimer100";
	f.func = sampOnTimer100;
	callback_funcs.push_back(f);

	//-sampOnFilterScriptExit
	//-sampOnFilterScriptInit
	
	//-sampOnGameModeExit
	//-sampOnGameModeInit
	
	f.name = "sampOnObjectMoved";
	f.func = sampOnObjectMoved;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerCommandText";
	f.func = sampOnPlayerCommandText;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerConnect";
	f.func = sampOnPlayerConnect;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerDeath";
	f.func = sampOnPlayerDeath;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerDisconnect";
	f.func = sampOnPlayerDisconnect;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerEnterCheckpoint";
	f.func = sampOnPlayerEnterCheckpoint;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerEnterRaceCheckpoint";
	f.func = sampOnPlayerEnterRaceCheckpoint;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerEnterVehicle";
	f.func = sampOnPlayerEnterVehicle;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerExitedMenu";
	f.func = sampOnPlayerExitedMenu;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerExitVehicle";
	f.func = sampOnPlayerExitVehicle;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerInfoChange";
	f.func = sampOnPlayerInfoChange;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerInteriorChange";
	f.func = sampOnPlayerInteriorChange;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerKeyStateChange";
	f.func = sampOnPlayerKeyStateChange;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerLeaveCheckpoint";
	f.func = sampOnPlayerLeaveCheckpoint;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerLeaveRaceCheckpoint";
	f.func = sampOnPlayerLeaveRaceCheckpoint;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerObjectMoved";
	f.func = sampOnPlayerObjectMoved;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerPickUpPickup";
	f.func = sampOnPlayerPickUpPickup;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerPrivmsg";
	f.func = sampOnPlayerPrivmsg;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerRequestClass";
	f.func = sampOnPlayerRequestClass;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerRequestSpawn";
	f.func = sampOnPlayerRequestSpawn;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerSelectedMenuRow";
	f.func = sampOnPlayerSelectedMenuRow;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerSpawn";
	f.func = sampOnPlayerSpawn;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerStateChange";
	f.func = sampOnPlayerStateChange;
	callback_funcs.push_back(f);

	f.name = "sampOnPlayerText";
	f.func = sampOnPlayerText;
	callback_funcs.push_back(f);

	f.name = "sampOnRconCommand";
	f.func = sampOnRconCommand;
	callback_funcs.push_back(f);

	f.name = "sampOnVehicleDeath";
	f.func = sampOnVehicleDeath;
	callback_funcs.push_back(f);

	f.name = "sampOnVehicleMod";
	f.func = sampOnVehicleMod;
	callback_funcs.push_back(f);

	f.name = "sampOnVehiclePaintjob";
	f.func = sampOnVehiclePaintjob;
	callback_funcs.push_back(f);

	f.name = "sampOnVehicleRespray";
	f.func = sampOnVehicleRespray;
	callback_funcs.push_back(f);

	f.name = "sampOnVehicleSpawn";
	f.func = sampOnVehicleSpawn;
	callback_funcs.push_back(f);

	// -- Now about amx functions --

	sampAddPlayerClass = (t_sampAddPlayerClass)__sampFindNamedFunction(amx_funcs, "sampAddPlayerClass");
	sampAllowAdminTeleport = (t_sampAllowAdminTeleport)__sampFindNamedFunction(amx_funcs, "sampAllowAdminTeleport");
	sampAllowInteriorWeapons = (t_sampAllowInteriorWeapons)__sampFindNamedFunction(amx_funcs, "sampAllowInteriorWeapons");
	sampBan = (t_sampBan)__sampFindNamedFunction(amx_funcs, "sampBan");
	sampBanEx = (t_sampBanEx)__sampFindNamedFunction(amx_funcs, "sampBanEx");
	sampCreateExplosion = (t_sampCreateExplosion)__sampFindNamedFunction(amx_funcs, "sampCreateExplosion");
	sampCreatePickup = (t_sampCreatePickup)__sampFindNamedFunction(amx_funcs, "sampCreatePickup");
	sampDestroyPickup = (t_sampDestroyPickup)__sampFindNamedFunction(amx_funcs, "sampDestroyPickup");
	sampEnableTirePopping = (t_sampEnableTirePopping)__sampFindNamedFunction(amx_funcs, "sampEnableTirePopping");
	sampEnableZoneNames = (t_sampEnableZoneNames)__sampFindNamedFunction(amx_funcs, "sampEnableZoneNames");
	sampGameTextForAll = (t_sampGameTextForAll)__sampFindNamedFunction(amx_funcs, "sampGameTextForAll");
	sampGameTextForPlayer = (t_sampGameTextForPlayer)__sampFindNamedFunction(amx_funcs, "sampGameTextForPlayer");
	sampGangZoneCreate = (t_sampGangZoneCreate)__sampFindNamedFunction(amx_funcs, "sampGangZoneCreate");
	sampGangZoneDestroy = (t_sampGangZoneDestroy)__sampFindNamedFunction(amx_funcs, "sampGangZoneDestroy");
	sampGangZoneFlashForAll = (t_sampGangZoneFlashForAll)__sampFindNamedFunction(amx_funcs, "sampGangZoneFlashForAll");
	sampGangZoneFlashForPlayer = (t_sampGangZoneFlashForPlayer)__sampFindNamedFunction(amx_funcs, "sampGangZoneFlashForPlayer");
	sampGangZoneHideForAll = (t_sampGangZoneHideForAll)__sampFindNamedFunction(amx_funcs, "sampGangZoneHideForAll");
	sampGangZoneHideForPlayer = (t_sampGangZoneHideForPlayer)__sampFindNamedFunction(amx_funcs, "sampGangZoneHideForPlayer");
	sampGangZoneShowForAll = (t_sampGangZoneShowForAll)__sampFindNamedFunction(amx_funcs, "sampGangZoneShowForAll");
	sampGangZoneShowForPlayer = (t_sampGangZoneShowForPlayer)__sampFindNamedFunction(amx_funcs, "sampGangZoneShowForPlayer");
	sampGangZoneStopFlashForAll = (t_sampGangZoneStopFlashForAll)__sampFindNamedFunction(amx_funcs, "sampGangZoneStopFlashForAll");
	sampGangZoneStopFlashForPlayer = (t_sampGangZoneStopFlashForPlayer)__sampFindNamedFunction(amx_funcs, "sampGangZoneStopFlashForPlayer");
	sampIsPlayerAdmin = (t_sampIsPlayerAdmin)__sampFindNamedFunction(amx_funcs, "sampIsPlayerAdmin");
	sampKick = (t_sampKick)__sampFindNamedFunction(amx_funcs, "sampKick");
	sampLimitGlobalChatRadius = (t_sampLimitGlobalChatRadius)__sampFindNamedFunction(amx_funcs, "sampLimitGlobalChatRadius");
	sampSendClientMessage = (t_sampSendClientMessage)__sampFindNamedFunction(amx_funcs, "sampSendClientMessage");
	sampSendClientMessageToAll = (t_sampSendClientMessageToAll)__sampFindNamedFunction(amx_funcs, "sampSendClientMessageToAll");
	sampSendDeathMessage = (t_sampSendDeathMessage)__sampFindNamedFunction(amx_funcs, "sampSendDeathMessage");
	sampSendPlayerMessageToAll = (t_sampSendPlayerMessageToAll)__sampFindNamedFunction(amx_funcs, "sampSendPlayerMessageToAll");
	sampSendPlayerMessageToPlayer = (t_sampSendPlayerMessageToPlayer)__sampFindNamedFunction(amx_funcs, "sampSendPlayerMessageToPlayer");
	sampSetGameModeText = (t_sampSetGameModeText)__sampFindNamedFunction(amx_funcs, "sampSetGameModeText");
	sampSetGravity = (t_sampSetGravity)__sampFindNamedFunction(amx_funcs, "sampSetGravity");
	sampSetWeather = (t_sampSetWeather)__sampFindNamedFunction(amx_funcs, "sampSetWeather");
	sampSetWorldTime = (t_sampSetWorldTime)__sampFindNamedFunction(amx_funcs, "sampSetWorldTime");
	sampShowNameTags = (t_sampShowNameTags)__sampFindNamedFunction(amx_funcs, "sampShowNameTags");
	sampShowPlayerMarkers = (t_sampShowPlayerMarkers)__sampFindNamedFunction(amx_funcs, "sampShowPlayerMarkers");
	sampUsePlayerPedAnims = (t_sampUsePlayerPedAnims)__sampFindNamedFunction(amx_funcs, "sampUsePlayerPedAnims");		

	sampAllowPlayerTeleport = (t_sampAllowPlayerTeleport)__sampFindNamedFunction(amx_funcs, "sampAllowPlayerTeleport");
	sampApplyAnimation = (t_sampApplyAnimation)__sampFindNamedFunction(amx_funcs, "sampApplyAnimation");
	sampClearAnimations = (t_sampClearAnimations)__sampFindNamedFunction(amx_funcs, "sampClearAnimations");
	sampDisablePlayerCheckpoint = (t_sampDisablePlayerCheckpoint)__sampFindNamedFunction(amx_funcs, "sampDisablePlayerCheckpoint");
	sampDisablePlayerRaceCheckpoint = (t_sampDisablePlayerRaceCheckpoint)__sampFindNamedFunction(amx_funcs, "sampDisablePlayerRaceCheckpoint");
	sampForceClassSelection = (t_sampForceClassSelection)__sampFindNamedFunction(amx_funcs, "sampForceClassSelection");
	sampGetPlayerAmmo = (t_sampGetPlayerAmmo)__sampFindNamedFunction(amx_funcs, "sampGetPlayerAmmo");
	sampGetPlayerArmour = (t_sampGetPlayerArmour)__sampFindNamedFunction(amx_funcs, "sampGetPlayerArmour");
	sampGetPlayerColor = (t_sampGetPlayerColor)__sampFindNamedFunction(amx_funcs, "sampGetPlayerColor");
	sampGetPlayerFacingAngle = (t_sampGetPlayerFacingAngle)__sampFindNamedFunction(amx_funcs, "sampGetPlayerFacingAngle");
	sampGetPlayerHealth = (t_sampGetPlayerHealth)__sampFindNamedFunction(amx_funcs, "sampGetPlayerHealth");
	sampGetPlayerInterior = (t_sampGetPlayerInterior)__sampFindNamedFunction(amx_funcs, "sampGetPlayerInterior");
	sampGetPlayerIp = (t_sampGetPlayerIp)__sampFindNamedFunction(amx_funcs, "sampGetPlayerIp");
	sampGetPlayerKeys = (t_sampGetPlayerKeys)__sampFindNamedFunction(amx_funcs, "sampGetPlayerKeys");
	sampGetPlayerMoney = (t_sampGetPlayerMoney)__sampFindNamedFunction(amx_funcs, "sampGetPlayerMoney");
	sampGetPlayerName = (t_sampGetPlayerName)__sampFindNamedFunction(amx_funcs, "sampGetPlayerName");
	sampGetPlayerPing = (t_sampGetPlayerPing)__sampFindNamedFunction(amx_funcs, "sampGetPlayerPing");
	sampGetPlayerPos = (t_sampGetPlayerPos)__sampFindNamedFunction(amx_funcs, "sampGetPlayerPos");
	sampGetPlayerScore = (t_sampGetPlayerScore)__sampFindNamedFunction(amx_funcs, "sampGetPlayerScore");
	sampGetPlayerSkin = (t_sampGetPlayerSkin)__sampFindNamedFunction(amx_funcs, "sampGetPlayerSkin");
	sampGetPlayerSpecialAction = (t_sampGetPlayerSpecialAction)__sampFindNamedFunction(amx_funcs, "sampGetPlayerSpecialAction");
	sampGetPlayerState = (t_sampGetPlayerState)__sampFindNamedFunction(amx_funcs, "sampGetPlayerState");
	sampGetPlayerTeam = (t_sampGetPlayerTeam)__sampFindNamedFunction(amx_funcs, "sampGetPlayerTeam");
	sampGetPlayerTime = (t_sampGetPlayerTime)__sampFindNamedFunction(amx_funcs, "sampGetPlayerTime");
	sampGetPlayerVehicleID = (t_sampGetPlayerVehicleID)__sampFindNamedFunction(amx_funcs, "sampGetPlayerVehicleID");
	sampGetPlayerVirtualWorld = (t_sampGetPlayerVirtualWorld)__sampFindNamedFunction(amx_funcs, "sampGetPlayerVirtualWorld");
	sampGetPlayerWantedLevel = (t_sampGetPlayerWantedLevel)__sampFindNamedFunction(amx_funcs, "sampGetPlayerWantedLevel");
	sampGetPlayerWeapon = (t_sampGetPlayerWeapon)__sampFindNamedFunction(amx_funcs, "sampGetPlayerWeapon");
	sampGetPlayerWeaponData = (t_sampGetPlayerWeaponData)__sampFindNamedFunction(amx_funcs, "sampGetPlayerWeaponData");
	sampGivePlayerMoney = (t_sampGivePlayerMoney)__sampFindNamedFunction(amx_funcs, "sampGivePlayerMoney");
	sampGivePlayerWeapon = (t_sampGivePlayerWeapon)__sampFindNamedFunction(amx_funcs, "sampGivePlayerWeapon");
	sampIsPlayerConnected = (t_sampIsPlayerConnected)__sampFindNamedFunction(amx_funcs, "sampIsPlayerConnected");
	sampIsPlayerInAnyVehicle = (t_sampIsPlayerInAnyVehicle)__sampFindNamedFunction(amx_funcs, "sampIsPlayerInAnyVehicle");
	sampIsPlayerInCheckpoint = (t_sampIsPlayerInCheckpoint)__sampFindNamedFunction(amx_funcs, "sampIsPlayerInCheckpoint");
	sampIsPlayerInRaceCheckpoint = (t_sampIsPlayerInRaceCheckpoint)__sampFindNamedFunction(amx_funcs, "sampIsPlayerInRaceCheckpoint");
	sampIsPlayerInVehicle = (t_sampIsPlayerInVehicle)__sampFindNamedFunction(amx_funcs, "sampIsPlayerInVehicle");
	sampPlayerPlaySound = (t_sampPlayerPlaySound)__sampFindNamedFunction(amx_funcs, "sampPlayerPlaySound");
	sampPlayerSpectatePlayer = (t_sampPlayerSpectatePlayer)__sampFindNamedFunction(amx_funcs, "sampPlayerSpectatePlayer");
	sampPlayerSpectateVehicle = (t_sampPlayerSpectateVehicle)__sampFindNamedFunction(amx_funcs, "sampPlayerSpectateVehicle");
	sampPutPlayerInVehicle = (t_sampPutPlayerInVehicle)__sampFindNamedFunction(amx_funcs, "sampPutPlayerInVehicle");
	sampRemovePlayerFromVehicle = (t_sampRemovePlayerFromVehicle)__sampFindNamedFunction(amx_funcs, "sampRemovePlayerFromVehicle");
	sampRemovePlayerMapIcon = (t_sampRemovePlayerMapIcon)__sampFindNamedFunction(amx_funcs, "sampRemovePlayerMapIcon");
	sampResetPlayerMoney = (t_sampResetPlayerMoney)__sampFindNamedFunction(amx_funcs, "sampResetPlayerMoney");
	sampResetPlayerWeapons = (t_sampResetPlayerWeapons)__sampFindNamedFunction(amx_funcs, "sampResetPlayerWeapons");
	sampSetCameraBehindPlayer = (t_sampSetCameraBehindPlayer)__sampFindNamedFunction(amx_funcs, "sampSetCameraBehindPlayer");
	sampSetPlayerAmmo = (t_sampSetPlayerAmmo)__sampFindNamedFunction(amx_funcs, "sampSetPlayerAmmo");
	sampSetPlayerArmour = (t_sampSetPlayerArmour)__sampFindNamedFunction(amx_funcs, "sampSetPlayerArmour");
	sampSetPlayerCameraLookAt = (t_sampSetPlayerCameraLookAt)__sampFindNamedFunction(amx_funcs, "sampSetPlayerCameraLookAt");
	sampSetPlayerCameraPos = (t_sampSetPlayerCameraPos)__sampFindNamedFunction(amx_funcs, "sampSetPlayerCameraPos");
	sampSetPlayerCheckpoint = (t_sampSetPlayerCheckpoint)__sampFindNamedFunction(amx_funcs, "sampSetPlayerCheckpoint");
	sampSetPlayerColor = (t_sampSetPlayerColor)__sampFindNamedFunction(amx_funcs, "sampSetPlayerColor");
	sampSetPlayerFacingAngle = (t_sampSetPlayerFacingAngle)__sampFindNamedFunction(amx_funcs, "sampSetPlayerFacingAngle");
	sampSetPlayerHealth = (t_sampSetPlayerHealth)__sampFindNamedFunction(amx_funcs, "sampSetPlayerHealth");
	sampSetPlayerInterior = (t_sampSetPlayerInterior)__sampFindNamedFunction(amx_funcs, "sampSetPlayerInterior");
	sampSetPlayerMapIcon = (t_sampSetPlayerMapIcon)__sampFindNamedFunction(amx_funcs, "sampSetPlayerMapIcon");
	sampSetPlayerMarkerForPlayer = (t_sampSetPlayerMarkerForPlayer)__sampFindNamedFunction(amx_funcs, "sampSetPlayerMarkerForPlayer");
	sampSetPlayerName = (t_sampSetPlayerName)__sampFindNamedFunction(amx_funcs, "sampSetPlayerName");
	sampSetPlayerPos = (t_sampSetPlayerPos)__sampFindNamedFunction(amx_funcs, "sampSetPlayerPos");
	sampSetPlayerPosFindZ = (t_sampSetPlayerPosFindZ)__sampFindNamedFunction(amx_funcs, "sampSetPlayerPosFindZ");
	sampSetPlayerRaceCheckpoint = (t_sampSetPlayerRaceCheckpoint)__sampFindNamedFunction(amx_funcs, "sampSetPlayerRaceCheckpoint");
	sampSetPlayerScore = (t_sampSetPlayerScore)__sampFindNamedFunction(amx_funcs, "sampSetPlayerScore");
	sampSetPlayerSkin = (t_sampSetPlayerSkin)__sampFindNamedFunction(amx_funcs, "sampSetPlayerSkin");
	sampSetPlayerSpecialAction = (t_sampSetPlayerSpecialAction)__sampFindNamedFunction(amx_funcs, "sampSetPlayerSpecialAction");
	sampSetPlayerTeam = (t_sampSetPlayerTeam)__sampFindNamedFunction(amx_funcs, "sampSetPlayerTeam");
	sampSetPlayerTime = (t_sampSetPlayerTime)__sampFindNamedFunction(amx_funcs, "sampSetPlayerTime");
	sampSetPlayerVirtualWorld = (t_sampSetPlayerVirtualWorld)__sampFindNamedFunction(amx_funcs, "sampSetPlayerVirtualWorld");
	sampSetPlayerWantedLevel = (t_sampSetPlayerWantedLevel)__sampFindNamedFunction(amx_funcs, "sampSetPlayerWantedLevel");
	sampSetPlayerWeather = (t_sampSetPlayerWeather)__sampFindNamedFunction(amx_funcs, "sampSetPlayerWeather");
	sampSetPlayerWorldBounds = (t_sampSetPlayerWorldBounds)__sampFindNamedFunction(amx_funcs, "sampSetPlayerWorldBounds");
	sampSetSpawnInfo = (t_sampSetSpawnInfo)__sampFindNamedFunction(amx_funcs, "sampSetSpawnInfo");
	sampShowPlayerNameTagForPlayer = (t_sampShowPlayerNameTagForPlayer)__sampFindNamedFunction(amx_funcs, "sampShowPlayerNameTagForPlayer");
	sampSpawnPlayer = (t_sampSpawnPlayer)__sampFindNamedFunction(amx_funcs, "sampSpawnPlayer");
	sampTogglePlayerClock = (t_sampTogglePlayerClock)__sampFindNamedFunction(amx_funcs, "sampTogglePlayerClock");
	sampTogglePlayerControllable = (t_sampTogglePlayerControllable)__sampFindNamedFunction(amx_funcs, "sampTogglePlayerControllable");
	sampTogglePlayerSpectating = (t_sampTogglePlayerSpectating)__sampFindNamedFunction(amx_funcs, "sampTogglePlayerSpectating");

	sampAddVehicleComponent = (t_sampAddVehicleComponent)__sampFindNamedFunction(amx_funcs, "sampAddVehicleComponent");
	sampAttachTrailerToVehicle = (t_sampAttachTrailerToVehicle)__sampFindNamedFunction(amx_funcs, "sampAttachTrailerToVehicle");
	sampChangeVehicleColor = (t_sampChangeVehicleColor)__sampFindNamedFunction(amx_funcs, "sampChangeVehicleColor");
	sampChangeVehiclePaintjob = (t_sampChangeVehiclePaintjob)__sampFindNamedFunction(amx_funcs, "sampChangeVehiclePaintjob");
	sampCreateVehicle = (t_sampCreateVehicle)__sampFindNamedFunction(amx_funcs, "sampCreateVehicle");
	sampDestroyVehicle = (t_sampDestroyVehicle)__sampFindNamedFunction(amx_funcs, "sampDestroyVehicle");
	sampDetachTrailerFromVehicle = (t_sampDetachTrailerFromVehicle)__sampFindNamedFunction(amx_funcs, "sampDetachTrailerFromVehicle");
	sampGetVehicleHealth = (t_sampGetVehicleHealth)__sampFindNamedFunction(amx_funcs, "sampGetVehicleHealth");
	sampGetVehicleModel = (t_sampGetVehicleModel)__sampFindNamedFunction(amx_funcs, "sampGetVehicleModel");
	sampGetVehiclePos = (t_sampGetVehiclePos)__sampFindNamedFunction(amx_funcs, "sampGetVehiclePos");
	sampGetVehicleTrailer = (t_sampGetVehicleTrailer)__sampFindNamedFunction(amx_funcs, "sampGetVehicleTrailer");
	sampGetVehicleVirtualWorld = (t_sampGetVehicleVirtualWorld)__sampFindNamedFunction(amx_funcs, "sampGetVehicleVirtualWorld");
	sampGetVehicleZAngle = (t_sampGetVehicleZAngle)__sampFindNamedFunction(amx_funcs, "sampGetVehicleZAngle");
	sampIsTrailerAttachedToVehicle = (t_sampIsTrailerAttachedToVehicle)__sampFindNamedFunction(amx_funcs, "sampIsTrailerAttachedToVehicle");
	sampLinkVehicleToInterior = (t_sampLinkVehicleToInterior)__sampFindNamedFunction(amx_funcs, "sampLinkVehicleToInterior");
	sampRemoveVehicleComponent = (t_sampRemoveVehicleComponent)__sampFindNamedFunction(amx_funcs, "sampRemoveVehicleComponent");
	sampSetVehicleHealth = (t_sampSetVehicleHealth)__sampFindNamedFunction(amx_funcs, "sampSetVehicleHealth");
	sampSetVehicleNumberPlate = (t_sampSetVehicleNumberPlate)__sampFindNamedFunction(amx_funcs, "sampSetVehicleNumberPlate");
	sampSetVehicleParamsForPlayer = (t_sampSetVehicleParamsForPlayer)__sampFindNamedFunction(amx_funcs, "sampSetVehicleParamsForPlayer");
	sampSetVehiclePos = (t_sampSetVehiclePos)__sampFindNamedFunction(amx_funcs, "sampSetVehiclePos");
	sampSetVehicleToRespawn = (t_sampSetVehicleToRespawn)__sampFindNamedFunction(amx_funcs, "sampSetVehicleToRespawn");
	sampSetVehicleVirtualWorld = (t_sampSetVehicleVirtualWorld)__sampFindNamedFunction(amx_funcs, "sampSetVehicleVirtualWorld");
	sampSetVehicleZAngle = (t_sampSetVehicleZAngle)__sampFindNamedFunction(amx_funcs, "sampSetVehicleZAngle");

	//MessageBoxA(0, "WrapperRegister() end.", "Note", 0);
}
