//
// Functions.h
// This file contains all the function-definitions we'll be using inside
// of the LVP Core; defined for use with our Invoke class.
//

#pragma once

// STRUCT: PAWN_FUNCTION
// In here we define the function's name and parameters.
struct PAWN_FUNCTION
{
	int ParamCnt;			// Number of parameters for the function
	char Function[ 33 ];	// Name of the function, ex. "GetPlayerPos"
	char Params[ 18 ];		// Parameters for the function; i f v s
};

int PawnCommand( const PAWN_FUNCTION* Command, ... );

// Definition of pawn-functions;
// --------------------------------------------
// Parameters:
//   i = integer
//   f = float value
//   s = string
//   v = variable
//   p = string var (GetPlayerName etc.)

const PAWN_FUNCTION IsPlayerConnected =			{ 1,  "IsPlayerConnected",			"i" };
const PAWN_FUNCTION	SetPlayerPos =				{ 4,  "SetPlayerPos",				"ifff" };
const PAWN_FUNCTION AddPlayerClass =			{ 11, "AddPlayerClass",				"iffffiiiiii" };
const PAWN_FUNCTION SendRconCommand	=			{ 1,  "SendRconCommand",			"s" };
const PAWN_FUNCTION GetMaxPlayers =				{ 0,  "GetMaxPlayers",				"" };
const PAWN_FUNCTION GetPlayerPos =				{ 4,  "GetPlayerPos",				"ivvv" };
const PAWN_FUNCTION GetPlayerVirtualWorld =		{ 1,  "GetPlayerVirtualWorld",		"i" };
const PAWN_FUNCTION GetPlayerInterior =			{ 1,  "GetPlayerInterior",			"i" };
const PAWN_FUNCTION GetPlayerName =				{ 3,  "GetPlayerName",				"ipi" };
const PAWN_FUNCTION GetPlayerIP =				{ 3,  "GetPlayerIp",				"ipi" };
const PAWN_FUNCTION ShowPlayerNameTagForPlayer=	{ 3,  "ShowPlayerNameTagForPlayer", "iii" };
const PAWN_FUNCTION SendClientMessage =			{ 3,  "SendClientMessage",			"iis" };
const PAWN_FUNCTION SendClientMessageToAll =	{ 3,  "SendClientMessageToAll",		"is" };
const PAWN_FUNCTION SetPlayerVirtualWorld =		{ 2,  "SetPlayerVirtualWorld",		"ii" };
const PAWN_FUNCTION CreateVehicle =				{ 8,  "CreateVehicle",				"iffffiii" };
const PAWN_FUNCTION DestroyVehicle =			{ 1,  "DestroyVehicle",				"i" };
const PAWN_FUNCTION mCreateMenu =				{ 6,  "CreateMenu",					"siffff" };
const PAWN_FUNCTION mAddMenuItem =				{ 3,  "AddMenuItem",				"iis" };
const PAWN_FUNCTION SetMenuColumnHeader =		{ 3,  "SetMenuColumnHeader",		"iis" };
const PAWN_FUNCTION DisableMenuRow =			{ 2,  "DisableMenuRow",				"ii" };
const PAWN_FUNCTION IsValidMenu =				{ 1,  "IsValidMenu",				"i" };
const PAWN_FUNCTION ShowMenuForPlayer =			{ 2,  "ShowMenuForPlayer",			"ii" };
const PAWN_FUNCTION HideMenuForPlayer =			{ 2,  "HideMenuForPlayer",			"ii" };
const PAWN_FUNCTION SetPlayerMapIcon =			{ 7,  "SetPlayerMapIcon",			"iifffii" };
const PAWN_FUNCTION SetPlayerCheckpoint =		{ 5,  "SetPlayerCheckpoint",		"iffff" };
const PAWN_FUNCTION TogglePlayerControllable =	{ 2,  "TogglePlayerControllable",	"ii" };
const PAWN_FUNCTION GetPlayerFacingAngle =		{ 2,  "GetPlayerFacingAngle",		"iv" };
const PAWN_FUNCTION DisablePlayerCheckpoint =	{ 1,  "DisablePlayerCheckpoint",	"i" };
const PAWN_FUNCTION ApplyAnimation =			{ 9,  "ApplyAnimation",				"issfiiiii" };

const PAWN_FUNCTION TextDrawCreate =			{ 3,  "TextDrawCreate",				"ffs" };
const PAWN_FUNCTION TextDrawDestroy =			{ 1,  "TextDrawDestroy",			"i" };
const PAWN_FUNCTION TextDrawLetterSize =		{ 3,  "TextDrawLetterSize",			"iff" };
const PAWN_FUNCTION TextDrawTextSize =			{ 3,  "TextDrawTextSize",			"iff" };
const PAWN_FUNCTION TextDrawAlignment =			{ 2,  "TextDrawAlignment",			"ii" };
const PAWN_FUNCTION TextDrawColor =				{ 2,  "TextDrawColor",				"ii" };
const PAWN_FUNCTION TextDrawUseBox =			{ 2,  "TextDrawUseBox",				"ii" };
const PAWN_FUNCTION TextDrawBoxColor =			{ 2,  "TextDrawBoxColor",			"ii" };
const PAWN_FUNCTION TextDrawSetShadow =			{ 2,  "TextDrawSetShadow",			"ii" };
const PAWN_FUNCTION TextDrawSetOutline =		{ 2,  "TextDrawSetOutline",			"ii" };
const PAWN_FUNCTION TextDrawBackgroundColor =	{ 2,  "TextDrawBackgroundColor",	"ii" };
const PAWN_FUNCTION TextDrawFont =				{ 2,  "TextDrawFont",				"ii" };
const PAWN_FUNCTION TextDrawSetProportional =	{ 2,  "TextDrawSetProportional",	"ii" };
const PAWN_FUNCTION TextDrawShowForPlayer =		{ 2,  "TextDrawShowForPlayer",		"ii" };
const PAWN_FUNCTION TextDrawHideForPlayer =		{ 2,  "TextDrawHideForPlayer",		"ii" };
const PAWN_FUNCTION TextDrawShowForAll =		{ 1,  "TextDrawShowForAll",			"i" };
const PAWN_FUNCTION TextDrawHideForAll =		{ 1,  "TextDrawHideForAll",			"i" };

