#include "stdafx.h"
#include "samp.h"
#include "zcore.h"

#pragma warning (disable : 4312)

AMX *__gpAMX;

typedef int (*amx_function_t)(AMX *amx, cell* params);

#include "samp_internals.inl"

amx_function_t __sampFindFunction(char *name)
{
	if(!__gpAMX)
	{
		MessageBoxA(0, "1", "Error", MB_SYSTEMMODAL);
		return NULL;
	}

	int index;

	amx_FindNative(__gpAMX, name, &index);
	
	if(index == 2147483647)//The command cannot be found.
	{
		string msg = "Command can not be found:\r\n";
		msg += name;
		MessageBoxA(0, msg.c_str(), "Error", MB_SYSTEMMODAL);
		return NULL;
	}

	// Proceed with locating the memory address for this function;
	AMX_HEADER *hdr = (AMX_HEADER *) __gpAMX->base;
	unsigned int call_addr = (unsigned int)((AMX_FUNCSTUB *)
		((char *)(hdr) + (hdr)->natives + hdr->defsize * index))->address;

	if(call_addr == 0)//Could not locate the function's address.
	{
		MessageBoxA(0, "3", "Error", MB_SYSTEMMODAL);
		return NULL;
	}

	return (amx_function_t)call_addr;
}

void sampInitialize(AMX *pAMX)
{
	if(!pAMX)
		return;

	__gpAMX = pAMX;

	// -- Base --

	__sampAddPlayerClass				= __sampFindFunction("AddPlayerClass");
	__sampAddPlayerClassEx				= __sampFindFunction("AddPlayerClassEx");
	__sampAddStaticPickup				= __sampFindFunction("AddStaticPickup");
	__sampAddStaticVehicle				= __sampFindFunction("AddStaticVehicle");
	__sampAddStaticVehicleEx			= __sampFindFunction("AddStaticVehicleEx");
	__sampAllowAdminTeleport			= __sampFindFunction("AllowAdminTeleport");
	__sampAllowInteriorWeapons			= __sampFindFunction("AllowInteriorWeapons");
	__sampBan							= __sampFindFunction("Ban");
	__sampBanEx							= __sampFindFunction("BanEx");
	//-__sampCallLocalFunction			= __sampFindFunction("CallLocalFunction");
	//-__sampCallRemoteFunction			= __sampFindFunction("CallRemoteFunction");
	__sampCreateExplosion				= __sampFindFunction("CreateExplosion");
	__sampCreatePickup					= __sampFindFunction("CreatePickup");
	__sampDestroyPickup					= __sampFindFunction("DestroyPickup");
	__sampEnableTirePopping				= __sampFindFunction("EnableTirePopping");
	__sampEnableZoneNames				= __sampFindFunction("EnableZoneNames");
	__sampGameModeExit					= __sampFindFunction("GameModeExit");
	__sampGameTextForAll				= __sampFindFunction("GameTextForAll");
	__sampGameTextForPlayer				= __sampFindFunction("GameTextForPlayer");
	__sampGangZoneCreate				= __sampFindFunction("GangZoneCreate");
	__sampGangZoneDestroy				= __sampFindFunction("GangZoneDestroy");
	__sampGangZoneFlashForAll			= __sampFindFunction("GangZoneFlashForAll");
	__sampGangZoneFlashForPlayer		= __sampFindFunction("GangZoneFlashForPlayer");
	__sampGangZoneHideForAll			= __sampFindFunction("GangZoneHideForAll");
	__sampGangZoneHideForPlayer			= __sampFindFunction("GangZoneHideForPlayer");
	__sampGangZoneShowForAll			= __sampFindFunction("GangZoneShowForAll");
	__sampGangZoneShowForPlayer			= __sampFindFunction("GangZoneShowForPlayer");
	__sampGangZoneStopFlashForAll		= __sampFindFunction("GangZoneStopFlashForAll");
	__sampGangZoneStopFlashForPlayer	= __sampFindFunction("GangZoneStopFlashForPlayer");
	__sampGetMaxPlayers					= __sampFindFunction("GetMaxPlayers");
	__sampGetServerVarAsBool			= __sampFindFunction("GetServerVarAsBool");
	__sampGetServerVarAsInt				= __sampFindFunction("GetServerVarAsInt");
	__sampGetServerVarAsString			= __sampFindFunction("GetServerVarAsString");
	__sampGetTickCount					= __sampFindFunction("GetTickCount");
	__sampGetWeaponName					= __sampFindFunction("GetWeaponName");
	__sampIsPlayerAdmin					= __sampFindFunction("IsPlayerAdmin");
	__sampKick							= __sampFindFunction("Kick");
	__sampKillTimer						= __sampFindFunction("KillTimer");
	__sampLimitGlobalChatRadius			= __sampFindFunction("LimitGlobalChatRadius");
	__sampSendClientMessage				= __sampFindFunction("SendClientMessage");
	__sampSendClientMessageToAll		= __sampFindFunction("SendClientMessageToAll");
	__sampSendDeathMessage				= __sampFindFunction("SendDeathMessage");
	__sampSendPlayerMessageToAll		= __sampFindFunction("SendPlayerMessageToAll");
	__sampSendPlayerMessageToPlayer		= __sampFindFunction("SendPlayerMessageToPlayer");
	__sampSendRconCommand				= __sampFindFunction("SendRconCommand");
	__sampSetDeathDropAmount			= __sampFindFunction("SetDeathDropAmount");
	__sampSetDisabledWeapons			= __sampFindFunction("SetDisabledWeapons");
	__sampSetGameModeText				= __sampFindFunction("SetGameModeText");
	__sampSetGravity					= __sampFindFunction("SetGravity");
	__sampSetTeamCount					= __sampFindFunction("SetTeamCount");
	__sampSetTimer						= __sampFindFunction("SetTimer");
	__sampSetTimerEx					= __sampFindFunction("SetTimerEx");
	__sampSetWeather					= __sampFindFunction("SetWeather");
	__sampSetWorldTime					= __sampFindFunction("SetWorldTime");
	__sampShowNameTags					= __sampFindFunction("ShowNameTags");
	__sampShowPlayerMarkers				= __sampFindFunction("ShowPlayerMarkers");
	__sampUsePlayerPedAnims				= __sampFindFunction("UsePlayerPedAnims");

	// -- Player --

	__sampAllowPlayerTeleport			= __sampFindFunction("AllowPlayerTeleport");
	__sampApplyAnimation				= __sampFindFunction("ApplyAnimation");
	__sampClearAnimations				= __sampFindFunction("ClearAnimations");
	__sampDisablePlayerCheckpoint		= __sampFindFunction("DisablePlayerCheckpoint");
	__sampDisablePlayerRaceCheckpoint	= __sampFindFunction("DisablePlayerRaceCheckpoint");
	__sampForceClassSelection			= __sampFindFunction("ForceClassSelection");
	__sampGetPlayerAmmo					= __sampFindFunction("GetPlayerAmmo");
	__sampGetPlayerArmour				= __sampFindFunction("GetPlayerArmour");
	__sampGetPlayerColor				= __sampFindFunction("GetPlayerColor");
	__sampGetPlayerFacingAngle			= __sampFindFunction("GetPlayerFacingAngle");
	__sampGetPlayerHealth				= __sampFindFunction("GetPlayerHealth");
	__sampGetPlayerInterior				= __sampFindFunction("GetPlayerInterior");
	__sampGetPlayerIp					= __sampFindFunction("GetPlayerIp");
	__sampGetPlayerKeys					= __sampFindFunction("GetPlayerKeys");
	__sampGetPlayerMoney				= __sampFindFunction("GetPlayerMoney");
	__sampGetPlayerName					= __sampFindFunction("GetPlayerName");
	__sampGetPlayerPing					= __sampFindFunction("GetPlayerPing");
	__sampGetPlayerPos					= __sampFindFunction("GetPlayerPos");
	__sampGetPlayerScore				= __sampFindFunction("GetPlayerScore");
	__sampGetPlayerSkin					= __sampFindFunction("GetPlayerSkin");
	__sampGetPlayerSpecialAction		= __sampFindFunction("GetPlayerSpecialAction");
	__sampGetPlayerState				= __sampFindFunction("GetPlayerState");
	__sampGetPlayerTeam					= __sampFindFunction("GetPlayerTeam");
	__sampGetPlayerTime					= __sampFindFunction("GetPlayerTime");
	__sampGetPlayerVehicleID			= __sampFindFunction("GetPlayerVehicleID");
	__sampGetPlayerVirtualWorld			= __sampFindFunction("GetPlayerVirtualWorld");
	__sampGetPlayerWantedLevel			= __sampFindFunction("GetPlayerWantedLevel");
	__sampGetPlayerWeapon				= __sampFindFunction("GetPlayerWeapon");
	__sampGetPlayerWeaponData			= __sampFindFunction("GetPlayerWeaponData");
	__sampGivePlayerMoney				= __sampFindFunction("GivePlayerMoney");
	__sampGivePlayerWeapon				= __sampFindFunction("GivePlayerWeapon");
	__sampIsPlayerConnected				= __sampFindFunction("IsPlayerConnected");
	__sampIsPlayerInAnyVehicle			= __sampFindFunction("IsPlayerInAnyVehicle");
	__sampIsPlayerInCheckpoint			= __sampFindFunction("IsPlayerInCheckpoint");
	__sampIsPlayerInRaceCheckpoint		= __sampFindFunction("IsPlayerInRaceCheckpoint");
	__sampIsPlayerInVehicle				= __sampFindFunction("IsPlayerInVehicle");
	__sampPlayerPlaySound				= __sampFindFunction("PlayerPlaySound");
	__sampPlayerSpectatePlayer			= __sampFindFunction("PlayerSpectatePlayer");
	__sampPlayerSpectateVehicle			= __sampFindFunction("PlayerSpectateVehicle");
	__sampPutPlayerInVehicle			= __sampFindFunction("PutPlayerInVehicle");
	__sampRemovePlayerFromVehicle		= __sampFindFunction("RemovePlayerFromVehicle");
	__sampRemovePlayerMapIcon			= __sampFindFunction("RemovePlayerMapIcon");
	__sampResetPlayerMoney				= __sampFindFunction("ResetPlayerMoney");
	__sampResetPlayerWeapons			= __sampFindFunction("ResetPlayerWeapons");
	__sampSetCameraBehindPlayer			= __sampFindFunction("SetCameraBehindPlayer");
	__sampSetPlayerAmmo					= __sampFindFunction("SetPlayerAmmo");
	__sampSetPlayerArmour				= __sampFindFunction("SetPlayerArmour");
	__sampSetPlayerCameraLookAt			= __sampFindFunction("SetPlayerCameraLookAt");
	__sampSetPlayerCameraPos			= __sampFindFunction("SetPlayerCameraPos");
	__sampSetPlayerCheckpoint			= __sampFindFunction("SetPlayerCheckpoint");
	__sampSetPlayerColor				= __sampFindFunction("SetPlayerColor");
	//-__sampSetPlayerDisabledWeapons	= __sampFindFunction("SetPlayerDisabledWeapons");
	__sampSetPlayerFacingAngle			= __sampFindFunction("SetPlayerFacingAngle");
	__sampSetPlayerHealth				= __sampFindFunction("SetPlayerHealth");
	__sampSetPlayerInterior				= __sampFindFunction("SetPlayerInterior");
	__sampSetPlayerMapIcon				= __sampFindFunction("SetPlayerMapIcon");
	__sampSetPlayerMarkerForPlayer		= __sampFindFunction("SetPlayerMarkerForPlayer");
	__sampSetPlayerName					= __sampFindFunction("SetPlayerName");
	__sampSetPlayerPos					= __sampFindFunction("SetPlayerPos");
	__sampSetPlayerPosFindZ				= __sampFindFunction("SetPlayerPosFindZ");
	__sampSetPlayerRaceCheckpoint		= __sampFindFunction("SetPlayerRaceCheckpoint");
	__sampSetPlayerScore				= __sampFindFunction("SetPlayerScore");
	__sampSetPlayerSkin					= __sampFindFunction("SetPlayerSkin");
	__sampSetPlayerSpecialAction		= __sampFindFunction("SetPlayerSpecialAction");
	__sampSetPlayerTeam					= __sampFindFunction("SetPlayerTeam");
	__sampSetPlayerTime					= __sampFindFunction("SetPlayerTime");
	__sampSetPlayerVirtualWorld			= __sampFindFunction("SetPlayerVirtualWorld");
	__sampSetPlayerWantedLevel			= __sampFindFunction("SetPlayerWantedLevel");
	__sampSetPlayerWeather				= __sampFindFunction("SetPlayerWeather");
	__sampSetPlayerWorldBounds			= __sampFindFunction("SetPlayerWorldBounds");
	__sampSetSpawnInfo					= __sampFindFunction("SetSpawnInfo");
	__sampShowPlayerNameTagForPlayer	= __sampFindFunction("ShowPlayerNameTagForPlayer");
	__sampSpawnPlayer					= __sampFindFunction("SpawnPlayer");
	__sampTogglePlayerClock				= __sampFindFunction("TogglePlayerClock");
	__sampTogglePlayerControllable		= __sampFindFunction("TogglePlayerControllable");
	__sampTogglePlayerSpectating		= __sampFindFunction("TogglePlayerSpectating");

	// -- Vehicle --

	__sampAddVehicleComponent			= __sampFindFunction("AddVehicleComponent");
	__sampAttachTrailerToVehicle		= __sampFindFunction("AttachTrailerToVehicle");
	__sampChangeVehicleColor			= __sampFindFunction("ChangeVehicleColor");
	__sampChangeVehiclePaintjob			= __sampFindFunction("ChangeVehiclePaintjob");
	__sampCreateVehicle					= __sampFindFunction("CreateVehicle");
	__sampDestroyVehicle				= __sampFindFunction("DestroyVehicle");
	__sampDetachTrailerFromVehicle		= __sampFindFunction("DetachTrailerFromVehicle");
	__sampGetVehicleHealth				= __sampFindFunction("GetVehicleHealth");
	__sampGetVehicleModel				= __sampFindFunction("GetVehicleModel");
	__sampGetVehiclePos					= __sampFindFunction("GetVehiclePos");
	__sampGetVehicleTrailer				= __sampFindFunction("GetVehicleTrailer");
	__sampGetVehicleVirtualWorld		= __sampFindFunction("GetVehicleVirtualWorld");
	__sampGetVehicleZAngle				= __sampFindFunction("GetVehicleZAngle");
	__sampIsTrailerAttachedToVehicle	= __sampFindFunction("IsTrailerAttachedToVehicle");
	__sampLinkVehicleToInterior			= __sampFindFunction("LinkVehicleToInterior");
	__sampRemoveVehicleComponent		= __sampFindFunction("RemoveVehicleComponent");
	__sampSetVehicleHealth				= __sampFindFunction("SetVehicleHealth");
	__sampSetVehicleNumberPlate			= __sampFindFunction("SetVehicleNumberPlate");
	__sampSetVehicleParamsForPlayer		= __sampFindFunction("SetVehicleParamsForPlayer");
	__sampSetVehiclePos					= __sampFindFunction("SetVehiclePos");
	__sampSetVehicleToRespawn			= __sampFindFunction("SetVehicleToRespawn");
	__sampSetVehicleVirtualWorld		= __sampFindFunction("SetVehicleVirtualWorld");
	__sampSetVehicleZAngle				= __sampFindFunction("SetVehicleZAngle");
}

void sampShutdown(void)
{
	__zcoreShutdown();
}

#include "samp_base.inl"
#include "samp_player.inl"
#include "samp_vehicle.inl"
