#pragma once

#include "stdafx.h"

extern AMX *__gpAMX;

void sampInitialize(AMX *pAMX);
void sampShutdown(void);

void sampAddPlayerClass(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo);
//void sampAddPlayerClassEx(int teamid, int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo);
//void sampAddStaticPickup(int model, int type, float X, float Y, float Z);
//void sampAddStaticVehicle(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, unsigned long color1, unsigned long color2);
//void sampAddStaticVehicleEx(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, unsigned long color1, unsigned long color2, int respawn_delay);
void sampAllowAdminTeleport(bool allow);
void sampAllowInteriorWeapons(bool allow);
void sampBan(int playerid);
void sampBanEx(int playerid, const char *reason);
//--void sampCallLocalFunction(const function[], const format[], {Float, _}:...);
//--void sampCallRemoteFunction(const function[], const format[], {Float, _}:...);
void sampCreateExplosion(float X, float Y, float Z, int type, float Radius);
int sampCreatePickup(int model, int type, float X, float Y, float Z);
void sampDestroyPickup(int pickup);
void sampEnableTirePopping(bool enable);
void sampEnableZoneNames(bool enable);
//--void sampGameModeExit();
void sampGameTextForAll(const char *string, int time, int style);
void sampGameTextForPlayer(int playerid, const char *string, int time, int style);
int sampGangZoneCreate(float minx, float miny, float maxx, float maxy);
void sampGangZoneDestroy(int zone);
void sampGangZoneFlashForAll(int zone, unsigned long flashcolor);
void sampGangZoneFlashForPlayer(int playerid, int zone, unsigned long flashcolor);
void sampGangZoneHideForAll(int zone);
void sampGangZoneHideForPlayer(int playerid, int zone);
void sampGangZoneShowForAll(int zone, unsigned long color);
void sampGangZoneShowForPlayer(int playerid, int zone, unsigned long color);
void sampGangZoneStopFlashForAll(int zone);
void sampGangZoneStopFlashForPlayer(int playerid, int zone);
//int sampGetMaxPlayers();
//int sampGetServerVarAsBool(const varname[]);
//int sampGetServerVarAsInt(const varname[]);
//void sampGetServerVarAsString(const varname[], buffer[], len);
//int sampGetTickCount();
//void sampGetWeaponName(weaponid, const weapon[], len);
int sampIsPlayerAdmin(int playerid);
void sampKick(int playerid);
//--void sampKillTimer(timerid);
void sampLimitGlobalChatRadius(float chat_radius);
void sampSendClientMessage(int playerid, unsigned long color, const char *message);
void sampSendClientMessageToAll(unsigned long color, const char *message);
void sampSendDeathMessage(int killer, int killee, int weapon);
void sampSendPlayerMessageToAll(int senderid, const char *message);
void sampSendPlayerMessageToPlayer(int playerid, int senderid, const char *message);
//void sampSendRconCommand(command[]);
//void sampSetDeathDropAmount(amount);
//--void sampSetDisabledWeapons(...);
void sampSetGameModeText(const char *string);
void sampSetGravity(float gravity);
//void sampSetTeamCount(count);
//--void sampSetTimer(funcname[], interval, repeating);
//--void sampSetTimerEx(funcname[], interval, repeating, const format[], {Float, _}:...);
void sampSetWeather(int weatherid);
void sampSetWorldTime(int hour);
void sampShowNameTags(bool show);
void sampShowPlayerMarkers(bool show);
void sampUsePlayerPedAnims();		// Will cause the players to use CJ running/walking animations


// Menu
/*native Menu:CreateMenu(const title[], columns, float x, float y, float col1width, float col2width = 0.0);
native DestroyMenu(Menu:menuid);
native AddMenuItem(Menu:menuid, column, const menutext[]);
native SetMenuColumnHeader(Menu:menuid, column, const columnheader[]);
native ShowMenuForPlayer(Menu:menuid, playerid);
native HideMenuForPlayer(Menu:menuid, playerid);
native IsValidMenu(Menu:menuid);
native DisableMenu(Menu:menuid);
native DisableMenuRow(Menu:menuid, row);
native Menu:GetPlayerMenu(playerid);

// Text Draw
native Text:TextDrawCreate(float x, float y, text[]);
native TextDrawDestroy(Text:text);
native TextDrawLetterSize(Text:text, float x, float y);
native TextDrawTextSize(Text:text, float x, float y);
native TextDrawAlignment(Text:text, alignment);
native TextDrawColor(Text:text, color);
native TextDrawUseBox(Text:text, use);
native TextDrawBoxColor(Text:text, color);
native TextDrawSetShadow(Text:text, size);
native TextDrawSetOutline(Text:text, size);
native TextDrawBackgroundColor(Text:text, color);
native TextDrawFont(Text:text, font);
native TextDrawSetProportional(Text:text, set);
native TextDrawShowForPlayer(playerid, Text:text);
native TextDrawHideForPlayer(playerid, Text:text);
native TextDrawShowForAll(Text:text);
native TextDrawHideForAll(Text:text);*/

#define SAMP_SPECIAL_ACTION_NONE			0
#define SAMP_SPECIAL_ACTION_USEJETPACK		2
#define SAMP_SPECIAL_ACTION_DANCE1			5
#define SAMP_SPECIAL_ACTION_DANCE2			6
#define SAMP_SPECIAL_ACTION_DANCE3			7
#define SAMP_SPECIAL_ACTION_DANCE4			8
#define SAMP_SPECIAL_ACTION_HANDSUP			10

// Spectating
#define SAMP_SPECTATE_MODE_NORMAL	1
#define SAMP_SPECTATE_MODE_FIXED	2
#define SAMP_SPECTATE_MODE_SIDE		3

void sampAllowPlayerTeleport(int playerid, bool allow);
void sampApplyAnimation(int playerid, const char *animlib, const char *animname, float fS, int opt1, int opt2, int opt3, int opt4, int opt5);
void sampClearAnimations(int playerid);
void sampDisablePlayerCheckpoint(int playerid);
void sampDisablePlayerRaceCheckpoint(int playerid);
void sampForceClassSelection(int playerid);
int sampGetPlayerAmmo(int playerid);
void sampGetPlayerArmour(int playerid, float &armour);
unsigned long sampGetPlayerColor(int playerid);
void sampGetPlayerFacingAngle(int playerid, float &ang);
void sampGetPlayerHealth(int playerid, float &health);
int sampGetPlayerInterior(int playerid);
void sampGetPlayerIp(int playerid, char *name, int len);
void sampGetPlayerKeys(int playerid, unsigned long &keys, unsigned long &updown, unsigned long &leftright);
int sampGetPlayerMoney(int playerid);
void sampGetPlayerName(int playerid, char *name, int len);
int sampGetPlayerPing(int playerid);
void sampGetPlayerPos(int playerid, float &x, float &y, float &z);
int sampGetPlayerScore(int playerid);
int sampGetPlayerSkin(int playerid);
int sampGetPlayerSpecialAction(int playerid);
int sampGetPlayerState(int playerid);
int sampGetPlayerTeam(int playerid);
void sampGetPlayerTime(int playerid, int &hour, int &minute);
int sampGetPlayerVehicleID(int playerid);
int sampGetPlayerVirtualWorld(int playerid);
int sampGetPlayerWantedLevel(int playerid);
int sampGetPlayerWeapon(int playerid);
void sampGetPlayerWeaponData(int playerid, int slot, int &weapon, int &ammo);
void sampGivePlayerMoney(int playerid, int money);
void sampGivePlayerWeapon(int playerid, int weaponid, int ammo);
int sampIsPlayerConnected(int playerid);
int sampIsPlayerInAnyVehicle(int playerid);
int sampIsPlayerInCheckpoint(int playerid);
int sampIsPlayerInRaceCheckpoint(int playerid);
int sampIsPlayerInVehicle(int playerid, int vehicleid);
void sampPlayerPlaySound(int playerid, int soundid, float x, float y, float z);
void sampPlayerSpectatePlayer(int playerid, int targetplayerid, int mode);
void sampPlayerSpectateVehicle(int playerid, int targetvehicleid, int mode);
void sampPutPlayerInVehicle(int playerid, int vehicleid, int seatid);
void sampRemovePlayerFromVehicle(int playerid);
void sampRemovePlayerMapIcon(int playerid, int iconid);
void sampResetPlayerMoney(int playerid);
void sampResetPlayerWeapons(int playerid);
void sampSetCameraBehindPlayer(int playerid);
void sampSetPlayerAmmo(int playerid, int weaponslot, int ammo);
void sampSetPlayerArmour(int playerid, float armour);
void sampSetPlayerCameraLookAt(int playerid, float x, float y, float z);
void sampSetPlayerCameraPos(int playerid, float x, float y, float z);
void sampSetPlayerCheckpoint(int playerid, float x, float y, float z, float size);
void sampSetPlayerColor(int playerid, unsigned long color);
//-void SetPlayerDisabledWeapons(int playerid, ...);
void sampSetPlayerFacingAngle(int playerid, float ang);
void sampSetPlayerHealth(int playerid, float health);
void sampSetPlayerInterior(int playerid, int interiorid);
int sampSetPlayerMapIcon(int playerid, int iconid, float x, float y, float z, int markertype, unsigned long color);
void sampSetPlayerMarkerForPlayer(int playerid, int showplayerid, unsigned long color);
void sampSetPlayerName(int playerid, const char *name);
void sampSetPlayerPos(int playerid, float x, float y, float z);
void sampSetPlayerPosFindZ(int playerid, float x, float y, float z);
void sampSetPlayerRaceCheckpoint(int playerid, int type, float x, float y, float z, float nextx, float nexty, float nextz, float size);
void sampSetPlayerScore(int playerid, int score);
void sampSetPlayerSkin(int playerid, int skinid);
void sampSetPlayerSpecialAction(int playerid, int actionid);
void sampSetPlayerTeam(int playerid, int teamid);
void sampSetPlayerTime(int playerid, int hour, int minute);
void sampSetPlayerVirtualWorld(int playerid, int worldid);
void sampSetPlayerWantedLevel(int playerid, int level);
void sampSetPlayerWeather(int playerid, int weather);
void sampSetPlayerWorldBounds(int playerid, float x_max, float x_min, float y_max, float y_min);
void sampSetSpawnInfo(int playerid, int team, int skin, float x, float y, float z, float rotation, int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo);
void sampShowPlayerNameTagForPlayer(int playerid, int showplayerid, bool show);
void sampSpawnPlayer(int playerid);
void sampTogglePlayerClock(int playerid, bool toggle);
void sampTogglePlayerControllable(int playerid, bool toggle);
void sampTogglePlayerSpectating(int playerid, bool toggle);

void sampAddVehicleComponent(int vehicleid, int componentid);
void sampAttachTrailerToVehicle(int trailerid, int vehicleid);
void sampChangeVehicleColor(int vehicleid, unsigned long color1, unsigned long color2);
void sampChangeVehiclePaintjob(int vehicleid, int paintjobid);
int sampCreateVehicle(int vehicletype, float x, float y, float z, float rotation, unsigned long color1, unsigned long color2, int respawn_delay);
void sampDestroyVehicle(int vehicleid);
void sampDetachTrailerFromVehicle(int vehicleid);
void sampGetVehicleHealth(int vehicleid, float &health);
int sampGetVehicleModel(int vehicleid);
void sampGetVehiclePos(int vehicleid, float &x, float &y, float &z);
int sampGetVehicleTrailer(int vehicleid);
int sampGetVehicleVirtualWorld(int vehicleid);
void sampGetVehicleZAngle(int vehicleid, float &z_angle);
int sampIsTrailerAttachedToVehicle(int vehicleid);
void sampLinkVehicleToInterior(int vehicleid, int interiorid);
void sampRemoveVehicleComponent(int vehicleid, int componentid);
void sampSetVehicleHealth(int vehicleid, float health);
void sampSetVehicleNumberPlate(int vehicleid, const char *numberplate);
void sampSetVehicleParamsForPlayer(int vehicleid, int playerid, bool objective, bool doorslocked);
void sampSetVehiclePos(int vehicleid, float x, float y, float z);
void sampSetVehicleToRespawn(int vehicleid);
void sampSetVehicleVirtualWorld(int vehicleid, int worldid);
void sampSetVehicleZAngle(int vehicleid, float z_angle);
