void sampAddPlayerClass(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle,
	int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo)
{
	cell args[12];
	
	args[0] = 11 * sizeof(cell);

	args[1] = modelid;
	args[2] = amx_ftoc(spawn_x);
	args[3] = amx_ftoc(spawn_y);
	args[4] = amx_ftoc(spawn_z);
	args[5] = amx_ftoc(z_angle);
	
	args[6] = weapon1;
	args[7] = weapon1_ammo;
	args[8] = weapon2;
	args[9] = weapon2_ammo;
	args[10] = weapon3;
	args[11] = weapon3_ammo;

	__sampAddPlayerClass(__gpAMX, args);
}

//void sampAddPlayerClassEx(int teamid, int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo);
//void sampAddStaticPickup(int model, int type, float X, float Y, float Z);
//void sampAddStaticVehicle(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, unsigned long color1, unsigned long color2);
//void sampAddStaticVehicleEx(int modelid, float spawn_x, float spawn_y, float spawn_z, float z_angle, unsigned long color1, unsigned long color2, int respawn_delay);
void sampAllowAdminTeleport(bool allow)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = allow;

	__sampAllowAdminTeleport(__gpAMX, args);
}
void sampAllowInteriorWeapons(bool allow)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = allow;

	__sampAllowInteriorWeapons(__gpAMX, args);
}
void sampBan(int playerid)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = playerid;

	__sampBan(__gpAMX, args);
}

void sampBanEx(int playerid, const char *reason)
{
	cell args[3];
	cell *phys_addr;

	args[0] = 2 * sizeof(cell);
	args[1] = playerid;

	size_t len = strlen(reason);

	amx_Allot(__gpAMX, (int)(len + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, reason, 0, 0, len + 1);

	__sampBanEx(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
}

//--void sampCallLocalFunction(const function[], const format[], {Float, _}:...);
//--void sampCallRemoteFunction(const function[], const format[], {Float, _}:...);

void sampCreateExplosion(float X, float Y, float Z, int type, float Radius)
{
	cell args[6];
	
	args[0] = 5 * sizeof(cell);

	args[1] = amx_ftoc(X);
	args[2] = amx_ftoc(Y);
	args[3] = amx_ftoc(Z);
	args[4] = type;
	args[5] = amx_ftoc(Radius);
	
	__sampCreateExplosion(__gpAMX, args);
}

int sampCreatePickup(int model, int type, float X, float Y, float Z)
{
	cell args[6];
	
	args[0] = 5 * sizeof(cell);

	args[1] = model;
	args[2] = type;
	args[3] = amx_ftoc(X);
	args[4] = amx_ftoc(Y);
	args[5] = amx_ftoc(Z);
	
	return __sampCreatePickup(__gpAMX, args);
}

void sampDestroyPickup(int pickup)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = pickup;

	__sampDestroyPickup(__gpAMX, args);
}

void sampEnableTirePopping(bool enable)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = enable;

	__sampEnableTirePopping(__gpAMX, args);
}

void sampEnableZoneNames(bool enable)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = enable;

	__sampEnableZoneNames(__gpAMX, args);
}

//void sampGameModeExit();
void sampGameTextForAll(const char *string, int time, int style)
{
	cell args[4];
	cell *phys_addr;

	args[0] = 3 * sizeof(cell);
	
	size_t len = strlen(string);

	amx_Allot(__gpAMX, (int)(len + 1), args + 1, &phys_addr);
	amx_SetString(phys_addr, string, 0, 0, len + 1);

	args[2] = time;
	args[3] = style;

	__sampGameTextForPlayer(__gpAMX, args);

	amx_Release(__gpAMX, args[1]);
}

void sampGameTextForPlayer(int playerid, const char *string, int time, int style)
{
	cell args[5];
	cell *phys_addr;

	args[0] = 4 * sizeof(cell);
	args[1] = playerid;

	size_t len = strlen(string);

	amx_Allot(__gpAMX, (int)(len + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, string, 0, 0, len + 1);

	args[3] = time;
	args[4] = style;

	__sampGameTextForPlayer(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
}

int sampGangZoneCreate(float minx, float miny, float maxx, float maxy)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = amx_ftoc(minx);
	args[2] = amx_ftoc(miny);
	args[3] = amx_ftoc(maxx);
	args[4] = amx_ftoc(maxy);
	
	return __sampGangZoneCreate(__gpAMX, args);
}

void sampGangZoneDestroy(int zone)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = zone;

	__sampGangZoneDestroy(__gpAMX, args);
}

void sampGangZoneFlashForAll(int zone, unsigned long flashcolor)
{
	cell args[3];	
	args[0] = 2 * sizeof(cell);
	args[1] = zone;
	args[2] = flashcolor;

	__sampGangZoneFlashForAll(__gpAMX, args);
}

void sampGangZoneFlashForPlayer(int playerid, int zone, unsigned long flashcolor)
{
	cell args[4];	
	args[0] = 3 * sizeof(cell);
	args[1] = playerid;
	args[2] = zone;
	args[3] = flashcolor;

	__sampGangZoneFlashForPlayer(__gpAMX, args);
}

void sampGangZoneHideForAll(int zone)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = zone;

	__sampGangZoneHideForAll(__gpAMX, args);
}

void sampGangZoneHideForPlayer(int playerid, int zone)
{
	cell args[3];	
	args[0] = 2 * sizeof(cell);
	args[1] = playerid;
	args[2] = zone;

	__sampGangZoneHideForPlayer(__gpAMX, args);
}

void sampGangZoneShowForAll(int zone, unsigned long color)
{
	cell args[3];	
	args[0] = 2 * sizeof(cell);
	args[1] = zone;
	args[2] = color;

	__sampGangZoneShowForAll(__gpAMX, args);
}

void sampGangZoneShowForPlayer(int playerid, int zone, unsigned long color)
{
	cell args[4];	
	args[0] = 3 * sizeof(cell);
	args[1] = playerid;
	args[2] = zone;
	args[3] = color;//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	__sampGangZoneShowForPlayer(__gpAMX, args);
}

void sampGangZoneStopFlashForAll(int zone)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = zone;

	__sampGangZoneStopFlashForAll(__gpAMX, args);
}

void sampGangZoneStopFlashForPlayer(int playerid, int zone)
{
	cell args[3];	
	args[0] = 2 * sizeof(cell);
	args[1] = playerid;
	args[2] = zone;

	__sampGangZoneStopFlashForPlayer(__gpAMX, args);
}

//int sampGetMaxPlayers();
//bool sampGetServerVarAsBool(const varname[]);
//int sampGetServerVarAsInt(const varname[]);
//void sampGetServerVarAsString(const varname[], buffer[], len);
//int sampGetTickCount();
//void sampGetWeaponName(weaponid, const weapon[], len);

int sampIsPlayerAdmin(int playerid)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = playerid;

	return __sampIsPlayerAdmin(__gpAMX, args);
}

void sampKick(int playerid)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = playerid;

	__sampKick(__gpAMX, args);
}

//--void sampKillTimer(timerid);

void sampLimitGlobalChatRadius(float chat_radius)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = amx_ftoc(chat_radius);

	__sampLimitGlobalChatRadius(__gpAMX, args);
}

void sampSendClientMessage(int playerid, unsigned long color, const char *message)
{
	cell args[4];
	cell *phys_addr;

	args[0] = 3 * sizeof(cell);
	args[1] = playerid;
	args[2] = color;

	size_t len = strlen(message);

	amx_Allot(__gpAMX, (int)(len + 1), args + 3, &phys_addr);
	amx_SetString(phys_addr, message, 0, 0, len + 1);

	__sampSendClientMessage(__gpAMX, args);

	amx_Release(__gpAMX, args[3]);
}

void sampSendClientMessageToAll(unsigned long color, const char *message)
{
	cell args[3];
	cell *phys_addr;

	args[0] = 2 * sizeof(cell);
	args[1] = color;

	size_t len = strlen(message);

	amx_Allot(__gpAMX, (int)(len + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, message, 0, 0, len + 1);

	__sampSendClientMessageToAll(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
}

void sampSendDeathMessage(int killer, int killee, int weapon)
{
	cell args[4];
	args[0] = 3 * sizeof(cell);
	args[1] = killer;
	args[2] = killee;
	args[3] = weapon;

	__sampSendDeathMessage(__gpAMX, args);
}

void sampSendPlayerMessageToAll(int senderid, const char *message)
{
	cell args[3];
	cell *phys_addr;

	args[0] = 2 * sizeof(cell);
	args[1] = senderid;

	size_t len = strlen(message);

	amx_Allot(__gpAMX, (int)(len + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, message, 0, 0, len + 1);

	__sampSendPlayerMessageToAll(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
}

void sampSendPlayerMessageToPlayer(int playerid, int senderid, const char *message)
{
	cell args[4];
	cell *phys_addr;

	args[0] = 3 * sizeof(cell);
	args[1] = playerid;
	args[2] = senderid;

	size_t len = strlen(message);

	amx_Allot(__gpAMX, (int)(len + 1), args + 3, &phys_addr);
	amx_SetString(phys_addr, message, 0, 0, len + 1);

	__sampSendPlayerMessageToPlayer(__gpAMX, args);

	amx_Release(__gpAMX, args[3]);
}

//void sampSendRconCommand(command[]);
//void sampSetDeathDropAmount(amount);
//void sampSetDisabledWeapons(...);

void sampSetGameModeText(const char *string)
{
	cell args[2];
	cell *phys_addr;

	args[0] = 1 * sizeof(cell);
	
	size_t len = strlen(string);

	amx_Allot(__gpAMX, (int)(len + 1), args + 1, &phys_addr);
	amx_SetString(phys_addr, string, 0, 0, len + 1);

	__sampSetGameModeText(__gpAMX, args);

	amx_Release(__gpAMX, args[1]);
}

void sampSetGravity(float gravity)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = amx_ftoc(gravity);

	__sampSetGravity(__gpAMX, args);
}

//void sampSetTeamCount(count);
//--void sampSetTimer(funcname[], interval, repeating);
//--void sampSetTimerEx(funcname[], interval, repeating, const format[], {Float, _}:...);

void sampSetWeather(int weatherid)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = weatherid;

	__sampSetWeather(__gpAMX, args);
}

void sampSetWorldTime(int hour)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = hour;

	__sampSetWorldTime(__gpAMX, args);
}

void sampShowNameTags(bool show)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = (int)show;

	__sampShowNameTags(__gpAMX, args);
}

void sampShowPlayerMarkers(bool show)
{
	cell args[2];	
	args[0] = 1 * sizeof(cell);
	args[1] = (int)show;

	__sampShowPlayerMarkers(__gpAMX, args);
}

void sampUsePlayerPedAnims()
{
	cell args[1];	
	args[0] = 0;
	
	__sampUsePlayerPedAnims(__gpAMX, args);
}
