#include "stdafx.h"

void sampAllowPlayerTeleport(int playerid, bool allow)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = allow;
	
	__sampAllowPlayerTeleport(__gpAMX, args);
}

void sampApplyAnimation(int playerid, const char *animlib, const char *animname,
	float fS, int opt1, int opt2, int opt3, int opt4, int opt5)
{
	cell args[10];
	cell *phys_addr;

	args[0] = 9 * sizeof(cell);
	
	args[1] = playerid;
	
	size_t len1 = strlen(animlib);
	size_t len2 = strlen(animname);

	amx_Allot(__gpAMX, (int)(len1 + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, animlib, 0, 0, len1 + 1);

	amx_Allot(__gpAMX, (int)(len2 + 1), args + 3, &phys_addr);
	amx_SetString(phys_addr, animname, 0, 0, len2 + 1);

	args[4] = amx_ftoc(fS);
	args[5] = opt1;
	args[6] = opt2;
	args[7] = opt3;
	args[8] = opt4;
	args[9] = opt5;

	__sampApplyAnimation(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
	amx_Release(__gpAMX, args[3]);
}

void sampClearAnimations(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampClearAnimations(__gpAMX, args);
}

void sampDisablePlayerCheckpoint(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampDisablePlayerCheckpoint(__gpAMX, args);
}

void sampDisablePlayerRaceCheckpoint(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampDisablePlayerRaceCheckpoint(__gpAMX, args);
}

void sampForceClassSelection(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampForceClassSelection(__gpAMX, args);
}

int sampGetPlayerAmmo(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerAmmo(__gpAMX, args);
}

void sampGetPlayerArmour(int playerid, float &armour)
{
	cell args[3];
	cell *phys_addr[1];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	
	__sampGetPlayerArmour(__gpAMX, args);

	armour = amx_ctof(**(phys_addr + 0));
	
	amx_Release(__gpAMX, args[2]);
}

unsigned long sampGetPlayerColor(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerColor(__gpAMX, args);
}

void sampGetPlayerFacingAngle(int playerid, float &ang)
{
	cell args[3];
	cell *phys_addr[1];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	
	__sampGetPlayerFacingAngle(__gpAMX, args);

	ang = amx_ctof(**(phys_addr + 0));
	
	amx_Release(__gpAMX, args[2]);
}

void sampGetPlayerHealth(int playerid, float &health)
{
	cell args[3];
	cell *phys_addr[1];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	
	__sampGetPlayerHealth(__gpAMX, args);

	health = amx_ctof(**(phys_addr + 0));
	
	amx_Release(__gpAMX, args[2]);
}

int sampGetPlayerInterior(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerInterior(__gpAMX, args);
}

void sampGetPlayerIp(int playerid, char *name, int len)
{
	cell args[4];
	cell *phys_addr;

	args[0] = 3 * sizeof(cell);
	
	args[1] = playerid;
	amx_Allot(__gpAMX, (int)len, args + 2, &phys_addr);
	args[3] = len;

	__sampGetPlayerIp(__gpAMX, args);

	amx_GetString(name, phys_addr, 0, len);
	amx_Release(__gpAMX, args[2]);
}

void sampGetPlayerKeys(int playerid, unsigned long &keys, unsigned long &updown, unsigned long &leftright)
{
	cell args[5];
	cell *phys_addr[3];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	amx_Allot(__gpAMX, 1, args + 3, phys_addr + 1);
	amx_Allot(__gpAMX, 1, args + 4, phys_addr + 2);
	
	__sampGetPlayerKeys(__gpAMX, args);

	keys = **(phys_addr + 0);
	updown = **(phys_addr + 1);
	leftright = **(phys_addr + 2);
	
	amx_Release(__gpAMX, args[2]);
	amx_Release(__gpAMX, args[3]);
	amx_Release(__gpAMX, args[4]);
}

int sampGetPlayerMoney(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerMoney(__gpAMX, args);
}

void sampGetPlayerName(int playerid, char *name, int len)
{
	cell args[4];
	cell *phys_addr;

	args[0] = 3 * sizeof(cell);
	
	args[1] = playerid;
	amx_Allot(__gpAMX, (int)len, args + 2, &phys_addr);
	args[3] = len;

	__sampGetPlayerName(__gpAMX, args);

	amx_GetString(name, phys_addr, 0, len);
	amx_Release(__gpAMX, args[2]);
}

int sampGetPlayerPing(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerPing(__gpAMX, args);
}

void sampGetPlayerPos(int playerid, float &x, float &y, float &z)
{
	cell args[5];
	cell *phys_addr[3];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	amx_Allot(__gpAMX, 1, args + 3, phys_addr + 1);
	amx_Allot(__gpAMX, 1, args + 4, phys_addr + 2);
	
	__sampGetPlayerPos(__gpAMX, args);

	x = amx_ctof(**(phys_addr + 0));
	y = amx_ctof(**(phys_addr + 1));
	z = amx_ctof(**(phys_addr + 2));

	amx_Release(__gpAMX, args[2]);
	amx_Release(__gpAMX, args[3]);
	amx_Release(__gpAMX, args[4]);
}

int sampGetPlayerScore(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerScore(__gpAMX, args);
}

int sampGetPlayerSkin(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerSkin(__gpAMX, args);
}

int sampGetPlayerSpecialAction(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerSpecialAction(__gpAMX, args);
}

int sampGetPlayerState(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerState(__gpAMX, args);
}

int sampGetPlayerTeam(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerTeam(__gpAMX, args);
}

void sampGetPlayerTime(int playerid, int &hour, int &minute)
{
	cell args[4];
	cell *phys_addr[2];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	amx_Allot(__gpAMX, 1, args + 3, phys_addr + 1);
	
	__sampGetPlayerTime(__gpAMX, args);

	hour = **(phys_addr + 0);
	minute = **(phys_addr + 1);
	
	amx_Release(__gpAMX, args[2]);
	amx_Release(__gpAMX, args[3]);
}

int sampGetPlayerVehicleID(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerVehicleID(__gpAMX, args);
}

int sampGetPlayerVirtualWorld(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerVirtualWorld(__gpAMX, args);
}

int sampGetPlayerWantedLevel(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerWantedLevel(__gpAMX, args);
}

int sampGetPlayerWeapon(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampGetPlayerWeapon(__gpAMX, args);
}

void sampGetPlayerWeaponData(int playerid, int slot, int &weapon, int &ammo)
{
	cell args[5];
	cell *phys_addr[2];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	args[2] = slot;
	amx_Allot(__gpAMX, 1, args + 3, phys_addr + 0);
	amx_Allot(__gpAMX, 1, args + 4, phys_addr + 1);
	
	__sampGetPlayerWeaponData(__gpAMX, args);

	weapon = **(phys_addr + 0);
	ammo = **(phys_addr + 1);
	
	amx_Release(__gpAMX, args[3]);
	amx_Release(__gpAMX, args[4]);
}

void sampGivePlayerMoney(int playerid, int money)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = money;
	
	__sampGivePlayerMoney(__gpAMX, args);
}

void sampGivePlayerWeapon(int playerid, int weaponid, int ammo)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = weaponid;
	args[3] = ammo;
	
	__sampGivePlayerWeapon(__gpAMX, args);
}

int sampIsPlayerConnected(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampIsPlayerConnected(__gpAMX, args);
}

int sampIsPlayerInAnyVehicle(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampIsPlayerInAnyVehicle(__gpAMX, args);
}

int sampIsPlayerInCheckpoint(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampIsPlayerInCheckpoint(__gpAMX, args);
}

int sampIsPlayerInRaceCheckpoint(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	return __sampIsPlayerInRaceCheckpoint(__gpAMX, args);
}

int sampIsPlayerInVehicle(int playerid, int vehicleid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = vehicleid;
	
	return __sampIsPlayerInVehicle(__gpAMX, args);
}

void sampPlayerPlaySound(int playerid, int soundid, float x, float y, float z)
{
	cell args[6];
	
	args[0] = 5 * sizeof(cell);

	args[1] = playerid;
	args[2] = soundid;
	args[3] = amx_ftoc(x);
	args[4] = amx_ftoc(y);
	args[5] = amx_ftoc(z);
	
	__sampPlayerPlaySound(__gpAMX, args);
}

void sampPlayerSpectatePlayer(int playerid, int targetplayerid, int mode)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = targetplayerid;
	args[3] = mode;
	
	__sampPlayerSpectatePlayer(__gpAMX, args);
}

void sampPlayerSpectateVehicle(int playerid, int targetvehicleid, int mode)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = targetvehicleid;
	args[3] = mode;
	
	__sampPlayerSpectateVehicle(__gpAMX, args);
}

void sampPutPlayerInVehicle(int playerid, int vehicleid, int seatid)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = vehicleid;
	args[3] = seatid;
	
	__sampPutPlayerInVehicle(__gpAMX, args);
}

void sampRemovePlayerFromVehicle(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampRemovePlayerFromVehicle(__gpAMX, args);
}

void sampRemovePlayerMapIcon(int playerid, int iconid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = iconid;
	
	__sampRemovePlayerMapIcon(__gpAMX, args);
}

void sampResetPlayerMoney(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampResetPlayerMoney(__gpAMX, args);
}

void sampResetPlayerWeapons(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampResetPlayerWeapons(__gpAMX, args);
}

void sampSetCameraBehindPlayer(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampSetCameraBehindPlayer(__gpAMX, args);
}

void sampSetPlayerAmmo(int playerid, int weaponslot, int ammo)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = weaponslot;
	args[3] = ammo;
	
	__sampSetPlayerAmmo(__gpAMX, args);
}

void sampSetPlayerArmour(int playerid, float armour)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(armour);
	
	__sampSetPlayerArmour(__gpAMX, args);
}

void sampSetPlayerCameraLookAt(int playerid, float x, float y, float z)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);

	__sampSetPlayerCameraLookAt(__gpAMX, args);
}

void sampSetPlayerCameraPos(int playerid, float x, float y, float z)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);

	__sampSetPlayerCameraPos(__gpAMX, args);
}

void sampSetPlayerCheckpoint(int playerid, float x, float y, float z, float size)
{
	cell args[6];
	
	args[0] = 5 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);
	args[5] = amx_ftoc(size);

	__sampSetPlayerCheckpoint(__gpAMX, args);
}

void sampSetPlayerColor(int playerid, unsigned long color)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = color;
	
	__sampSetPlayerColor(__gpAMX, args);
}

//void SetPlayerDisabledWeapons(int playerid, ...)

void sampSetPlayerFacingAngle(int playerid, float ang)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(ang);
	
	__sampSetPlayerFacingAngle(__gpAMX, args);
}

void sampSetPlayerHealth(int playerid, float health)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(health);
	
	__sampSetPlayerHealth(__gpAMX, args);
}

void sampSetPlayerInterior(int playerid, int interiorid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = interiorid;
	
	__sampSetPlayerInterior(__gpAMX, args);
}

int sampSetPlayerMapIcon(int playerid, int iconid, float x, float y, float z, int markertype, unsigned long color)
{
	cell args[8];
	
	args[0] = 7 * sizeof(cell);

	args[1] = playerid;
	args[2] = iconid;
	args[3] = amx_ftoc(x);
	args[4] = amx_ftoc(y);
	args[5] = amx_ftoc(z);
	args[6] = markertype;
	args[7] = color;

	return __sampSetPlayerMapIcon(__gpAMX, args);
}

void sampSetPlayerMarkerForPlayer(int playerid, int showplayerid, unsigned long color)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = showplayerid;
	args[3] = color;

	__sampSetPlayerMarkerForPlayer(__gpAMX, args);
}

void sampSetPlayerName(int playerid, const char *name)
{
	cell args[3];
	cell *phys_addr;

	args[0] = 2 * sizeof(cell);
	
	args[1] = playerid;
	
	size_t len = strlen(name);

	amx_Allot(__gpAMX, (int)(len + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, name, 0, 0, len + 1);

	__sampSetPlayerName(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
}

void sampSetPlayerPos(int playerid, float x, float y, float z)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);

	__sampSetPlayerPos(__gpAMX, args);
}

void sampSetPlayerPosFindZ(int playerid, float x, float y, float z)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);

	__sampSetPlayerPosFindZ(__gpAMX, args);
}

void sampSetPlayerRaceCheckpoint(int playerid, int type, float x, float y, float z,
	float nextx, float nexty, float nextz, float size)
{
	cell args[10];
	
	args[0] = 9 * sizeof(cell);

	args[1] = playerid;
	args[2] = type;
	args[3] = amx_ftoc(x);
	args[4] = amx_ftoc(y);
	args[5] = amx_ftoc(z);
	args[6] = amx_ftoc(nextx);
	args[7] = amx_ftoc(nexty);
	args[8] = amx_ftoc(nextz);
	args[9] = amx_ftoc(size);

	__sampSetPlayerRaceCheckpoint(__gpAMX, args);
}

void sampSetPlayerScore(int playerid, int score)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = score;
	
	__sampSetPlayerScore(__gpAMX, args);
}

void sampSetPlayerSkin(int playerid, int skinid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = skinid;
	
	__sampSetPlayerSkin(__gpAMX, args);
}

void sampSetPlayerSpecialAction(int playerid, int actionid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = actionid;
	
	__sampSetPlayerSpecialAction(__gpAMX, args);
}

void sampSetPlayerTeam(int playerid, int teamid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = teamid;
	
	__sampSetPlayerTeam(__gpAMX, args);
}

void sampSetPlayerTime(int playerid, int hour, int minute)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = hour;
	args[3] = minute;
	
	__sampSetPlayerTime(__gpAMX, args);
}

void sampSetPlayerVirtualWorld(int playerid, int worldid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = worldid;
	
	__sampSetPlayerVirtualWorld(__gpAMX, args);
}

void sampSetPlayerWantedLevel(int playerid, int level)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = level;
	
	__sampSetPlayerWantedLevel(__gpAMX, args);
}

void sampSetPlayerWeather(int playerid, int weather)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = weather;
	
	__sampSetPlayerWeather(__gpAMX, args);
}

void sampSetPlayerWorldBounds(int playerid, float x_max, float x_min, float y_max, float y_min)
{
	cell args[6];
	
	args[0] = 5 * sizeof(cell);

	args[1] = playerid;
	args[2] = amx_ftoc(x_max);
	args[3] = amx_ftoc(x_min);
	args[4] = amx_ftoc(y_max);
	args[5] = amx_ftoc(y_min);
	
	__sampSetPlayerWorldBounds(__gpAMX, args);
}

void sampSetSpawnInfo(int playerid, int team, int skin, float x, float y, float z, float rotation,
	int weapon1, int weapon1_ammo, int weapon2, int weapon2_ammo, int weapon3, int weapon3_ammo)
{
	cell args[14];
	
	args[0] = 13 * sizeof(cell);

	args[1] = playerid;
	args[2] = team;
	args[3] = skin;
	args[4] = amx_ftoc(x);
	args[5] = amx_ftoc(y);
	args[6] = amx_ftoc(z);
	args[7] = amx_ftoc(rotation);
	args[8] = weapon1;
	args[9] = weapon1_ammo;
	args[10] = weapon2;
	args[11] = weapon2_ammo;
	args[12] = weapon3;
	args[13] = weapon3_ammo;
	
	__sampSetSpawnInfo(__gpAMX, args);
}

void sampShowPlayerNameTagForPlayer(int playerid, int showplayerid, bool show)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = playerid;
	args[2] = showplayerid;
	args[3] = show;
	
	__sampShowPlayerNameTagForPlayer(__gpAMX, args);
}

void sampSpawnPlayer(int playerid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = playerid;
	
	__sampSpawnPlayer(__gpAMX, args);
}

void sampTogglePlayerClock(int playerid, bool toggle)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = toggle;
	
	__sampTogglePlayerClock(__gpAMX, args);
}

void sampTogglePlayerControllable(int playerid, bool toggle)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = toggle;
	
	__sampTogglePlayerControllable(__gpAMX, args);
}

void sampTogglePlayerSpectating(int playerid, bool toggle)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = playerid;
	args[2] = toggle;
	
	__sampTogglePlayerSpectating(__gpAMX, args);
}
