#include "stdafx.h"

void sampAddVehicleComponent(int vehicleid, int componentid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = componentid;
	
	__sampAddVehicleComponent(__gpAMX, args);
}

void sampAttachTrailerToVehicle(int trailerid, int vehicleid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = trailerid;
	args[2] = vehicleid;
	
	__sampAttachTrailerToVehicle(__gpAMX, args);
}

void sampChangeVehicleColor(int vehicleid, unsigned long color1, unsigned long color2)
{
	cell args[4];
	
	args[0] = 3 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = color1;
	args[3] = color2;
	
	__sampChangeVehicleColor(__gpAMX, args);
}

void sampChangeVehiclePaintjob(int vehicleid, int paintjobid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = paintjobid;
	
	__sampChangeVehiclePaintjob(__gpAMX, args);
}

int sampCreateVehicle(int vehicletype, float x, float y, float z, float rotation,
	unsigned long color1, unsigned long color2, int respawn_delay)
{
	cell args[9];
	
	args[0] = 8 * sizeof(cell);

	args[1] = vehicletype;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);
	args[5] = amx_ftoc(rotation);
	args[6] = color1;
	args[7] = color2;
	args[8] = respawn_delay;
	
	return __sampCreateVehicle(__gpAMX, args);
}

void sampDestroyVehicle(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	__sampDestroyVehicle(__gpAMX, args);
}

void sampDetachTrailerFromVehicle(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	__sampDetachTrailerFromVehicle(__gpAMX, args);
}

void sampGetVehicleHealth(int vehicleid, float &health)
{
	cell args[3];
	cell *phys_addr[1];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	
	__sampGetVehicleHealth(__gpAMX, args);

	health = amx_ctof(**(phys_addr + 0));
	
	amx_Release(__gpAMX, args[2]);
}

int sampGetVehicleModel(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	return __sampGetVehicleModel(__gpAMX, args);
}

void sampGetVehiclePos(int vehicleid, float &x, float &y, float &z)
{
	cell args[5];
	cell *phys_addr[3];
	
	args[0] = 4 * sizeof(cell);

	args[1] = vehicleid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	amx_Allot(__gpAMX, 1, args + 3, phys_addr + 1);
	amx_Allot(__gpAMX, 1, args + 4, phys_addr + 2);
	
	__sampGetVehiclePos(__gpAMX, args);

	x = amx_ctof(**(phys_addr + 0));
	y = amx_ctof(**(phys_addr + 1));
	z = amx_ctof(**(phys_addr + 2));

	amx_Release(__gpAMX, args[2]);
	amx_Release(__gpAMX, args[3]);
	amx_Release(__gpAMX, args[4]);
}

int sampGetVehicleTrailer(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	return __sampGetVehicleTrailer(__gpAMX, args);
}

int sampGetVehicleVirtualWorld(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	return __sampGetVehicleVirtualWorld(__gpAMX, args);
}

void sampGetVehicleZAngle(int vehicleid, float &z_angle)
{
	cell args[3];
	cell *phys_addr[1];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	amx_Allot(__gpAMX, 1, args + 2, phys_addr + 0);
	
	__sampGetVehicleZAngle(__gpAMX, args);

	z_angle = amx_ctof(**(phys_addr + 0));
	
	amx_Release(__gpAMX, args[2]);
}

int sampIsTrailerAttachedToVehicle(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	return __sampIsTrailerAttachedToVehicle(__gpAMX, args);
}

void sampLinkVehicleToInterior(int vehicleid, int interiorid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = interiorid;
	
	__sampLinkVehicleToInterior(__gpAMX, args);
}

void sampRemoveVehicleComponent(int vehicleid, int componentid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = componentid;
	
	__sampRemoveVehicleComponent(__gpAMX, args);
}

void sampSetVehicleHealth(int vehicleid, float health)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = amx_ftoc(health);
	
	__sampSetVehicleHealth(__gpAMX, args);
}

void sampSetVehicleNumberPlate(int vehicleid, const char *numberplate)
{
	cell args[3];
	cell *phys_addr;

	args[0] = 2 * sizeof(cell);
	args[1] = vehicleid;
	
	size_t len = strlen(numberplate);

	amx_Allot(__gpAMX, (int)(len + 1), args + 2, &phys_addr);
	amx_SetString(phys_addr, numberplate, 0, 0, len + 1);

	__sampSetVehicleNumberPlate(__gpAMX, args);

	amx_Release(__gpAMX, args[2]);
}

void sampSetVehicleParamsForPlayer(int vehicleid, int playerid, bool objective, bool doorslocked)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = playerid;
	args[3] = objective;
	args[4] = doorslocked;
	
	__sampSetVehicleParamsForPlayer(__gpAMX, args);
}

void sampSetVehiclePos(int vehicleid, float x, float y, float z)
{
	cell args[5];
	
	args[0] = 4 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = amx_ftoc(x);
	args[3] = amx_ftoc(y);
	args[4] = amx_ftoc(z);
	
	__sampSetVehiclePos(__gpAMX, args);
}

void sampSetVehicleToRespawn(int vehicleid)
{
	cell args[2];
	
	args[0] = 1 * sizeof(cell);

	args[1] = vehicleid;
	
	__sampSetVehicleToRespawn(__gpAMX, args);
}

void sampSetVehicleVirtualWorld(int vehicleid, int worldid)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = worldid;
	
	__sampSetVehicleVirtualWorld(__gpAMX, args);
}

void sampSetVehicleZAngle(int vehicleid, float z_angle)
{
	cell args[3];
	
	args[0] = 2 * sizeof(cell);

	args[1] = vehicleid;
	args[2] = amx_ftoc(z_angle);
	
	__sampSetVehicleZAngle(__gpAMX, args);
}
