#include "stdafx.h"
#include "zcore.h"

#include "samp.h"

typedef void (*logprintf_t)(char* format, ...);

extern logprintf_t logprintf;

#include "zcore_gamemode.inl"

cell AMX_NATIVE_CALL zcoreTimer100(AMX* amx, cell* params)
{
	if(__zcoreGamemodeChanged())//Note: This will be true at the first call.
		__zcoreLoadGamemode();

	//logprintf("c++ timer");

	if(!bGamemodeLoaded)
		return 0;

	return sampOnTimer100();
}

//OnFilterScriptExit();
//-zcoreOnFilterScriptExit(AMX *amx, cell *params)

//OnFilterScriptInit();
//-zcoreOnFilterScriptInit(AMX *amx, cell *params)

//OnGameModeExit();
//-zcoreOnGameModeExit(AMX *amx, cell *params)

//OnGameModeInit();
//-zcoreOnGameModeInit(AMX *amx, cell *params)

//OnObjectMoved(objectid);
cell AMX_NATIVE_CALL zcoreOnObjectMoved(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnObjectMoved(params[1]);
}

//OnPlayerCommandText(playerid, cmdtext[]);
cell AMX_NATIVE_CALL zcoreOnPlayerCommandText(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	int res = 0, len;
	cell *cstr;
	char *str;
	
	amx_GetAddr(__gpAMX, params[2], &cstr);
	amx_StrLen(cstr, &len);
	
	str = new char[len + 1];
	amx_GetString(str, cstr, 0, len + 1);
	
	res = sampOnPlayerCommandText(params[1], str);
	
	delete [] str;
	
	return res;
}

//OnPlayerConnect(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerConnect(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerConnect(params[1]);
}

//OnPlayerDeath(playerid, killerid, reason);
cell AMX_NATIVE_CALL zcoreOnPlayerDeath(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerDeath(params[1], params[2], params[3]);
}

//OnPlayerDisconnect(playerid, reason);
cell AMX_NATIVE_CALL zcoreOnPlayerDisconnect(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerDisconnect(params[1], params[2]);
}

//OnPlayerEnterCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerEnterCheckpoint(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerEnterCheckpoint(params[1]);
}

//OnPlayerEnterRaceCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerEnterRaceCheckpoint(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerEnterRaceCheckpoint(params[1]);
}

//OnPlayerEnterVehicle(playerid, vehicleid, ispassenger);
cell AMX_NATIVE_CALL zcoreOnPlayerEnterVehicle(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerEnterVehicle(params[1], params[2], params[3]);
}

//OnPlayerExitedMenu(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerExitedMenu(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerExitedMenu(params[1]);
}

//OnPlayerExitVehicle(playerid, vehicleid);
cell AMX_NATIVE_CALL zcoreOnPlayerExitVehicle(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerExitVehicle(params[1], params[2]);
}

//OnPlayerInfoChange(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerInfoChange(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerInfoChange(params[1]);
}

//OnPlayerInteriorChange(playerid, newinteriorid, oldinteriorid);
cell AMX_NATIVE_CALL zcoreOnPlayerInteriorChange(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerInteriorChange(params[1], params[2], params[3]);
}

//OnPlayerKeyStateChange(playerid, newkeys, oldkeys);
cell AMX_NATIVE_CALL zcoreOnPlayerKeyStateChange(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerKeyStateChange(params[1], params[2], params[3]);
}

//OnPlayerLeaveCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerLeaveCheckpoint(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerLeaveCheckpoint(params[1]);
}

//OnPlayerLeaveRaceCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerLeaveRaceCheckpoint(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerLeaveRaceCheckpoint(params[1]);
}

//OnPlayerObjectMoved(playerid, objectid);
cell AMX_NATIVE_CALL zcoreOnPlayerObjectMoved(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerObjectMoved(params[1], params[2]);
}

//OnPlayerPickUpPickup(playerid, pickupid);
cell AMX_NATIVE_CALL zcoreOnPlayerPickUpPickup(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerPickUpPickup(params[1], params[2]);
}

//OnPlayerPrivmsg(playerid, recieverid, text[]);
cell AMX_NATIVE_CALL zcoreOnPlayerPrivmsg(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	int res = 0, len;
	cell *cstr;
	char *str;
	
	amx_GetAddr(__gpAMX, params[3], &cstr);
	amx_StrLen(cstr, &len);
	
	str = new char[len + 1];
	amx_GetString(str, cstr, 0, len + 1);
	
	res = sampOnPlayerPrivmsg(params[1], params[2], str);
	
	delete [] str;
	
	return res;
}

//OnPlayerRequestClass(playerid, classid);
cell AMX_NATIVE_CALL zcoreOnPlayerRequestClass(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerRequestClass(params[1], params[2]);
}

//OnPlayerRequestSpawn(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerRequestSpawn(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerRequestSpawn(params[1]);
}

//OnPlayerSelectedMenuRow(playerid, row);
cell AMX_NATIVE_CALL zcoreOnPlayerSelectedMenuRow(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerSelectedMenuRow(params[1], params[2]);
}

//OnPlayerSpawn(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerSpawn(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerSpawn(params[1]);
}
//OnPlayerStateChange(playerid, newstate, oldstate);
cell AMX_NATIVE_CALL zcoreOnPlayerStateChange(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnPlayerStateChange(params[1], params[2], params[3]);
}

//OnPlayerText(playerid, text[]);
cell AMX_NATIVE_CALL zcoreOnPlayerText(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	int res = 0, len;
	cell *cstr;
	char *str;
	
	amx_GetAddr(__gpAMX, params[2], &cstr);
	amx_StrLen(cstr, &len);
	
	str = new char[len + 1];
	amx_GetString(str, cstr, 0, len + 1);
	
	res = sampOnPlayerText(params[1], str);
	
	delete [] str;
	
	return res;
}

//OnRconCommand(cmd[]);
cell AMX_NATIVE_CALL zcoreOnRconCommand(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	int res = 0, len;
	cell *cstr;
	char *str;
	
	amx_GetAddr(__gpAMX, params[1], &cstr);
	amx_StrLen(cstr, &len);
	
	str = new char[len + 1];
	amx_GetString(str, cstr, 0, len + 1);
	
	res = sampOnRconCommand(str);
	
	delete [] str;
	
	return res;
}

//OnVehicleDeath(vehicleid, killerid);
cell AMX_NATIVE_CALL zcoreOnVehicleDeath(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnVehicleDeath(params[1], params[2]);
}

//OnVehicleMod(vehicleid, componentid);
cell AMX_NATIVE_CALL zcoreOnVehicleMod(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnVehicleMod(params[1], params[2]);
}

//OnVehiclePaintjob(vehicleid, paintjobid);
cell AMX_NATIVE_CALL zcoreOnVehiclePaintjob(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnVehiclePaintjob(params[1], params[2]);
}

//OnVehicleRespray(vehicleid, color1, color2);
cell AMX_NATIVE_CALL zcoreOnVehicleRespray(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnVehicleRespray(params[1], params[2], params[3]);
}

//OnVehicleSpawn(vehicleid);
cell AMX_NATIVE_CALL zcoreOnVehicleSpawn(AMX *amx, cell *params)
{
	if(!bGamemodeLoaded)
		return 0;

	return sampOnVehicleSpawn(params[1]);
}
