HMODULE ghGamemode = 0;
bool bGamemodeLoaded = false;

//-typedef int (*t_sampOnGameModeExit)(void);
//-typedef int (*t_sampOnGameModeInit)(void);

typedef int (*t_sampOnLoad)(void);
typedef int (*t_sampOnUnload)(void);

typedef int (*t_sampOnTimer100)(void);

typedef int (*t_sampOnObjectMoved)(int objectid);
typedef int (*t_sampOnPlayerCommandText)(int playerid, const char *cmdtext);
typedef int (*t_sampOnPlayerConnect)(int playerid);
typedef int (*t_sampOnPlayerDeath)(int playerid, int killerid, int reason);
typedef int (*t_sampOnPlayerDisconnect)(int playerid, int reason);
typedef int (*t_sampOnPlayerEnterCheckpoint)(int playerid);
typedef int (*t_sampOnPlayerEnterRaceCheckpoint)(int playerid);
typedef int (*t_sampOnPlayerEnterVehicle)(int playerid, int vehicleid, int ispassenger);
typedef int (*t_sampOnPlayerExitedMenu)(int playerid);
typedef int (*t_sampOnPlayerExitVehicle)(int playerid, int vehicleid);
typedef int (*t_sampOnPlayerInfoChange)(int playerid);
typedef int (*t_sampOnPlayerInteriorChange)(int playerid, int newinteriorid, int oldinteriorid);
typedef int (*t_sampOnPlayerKeyStateChange)(int playerid, int newkeys, int oldkeys);
typedef int (*t_sampOnPlayerLeaveCheckpoint)(int playerid);
typedef int (*t_sampOnPlayerLeaveRaceCheckpoint)(int playerid);
typedef int (*t_sampOnPlayerObjectMoved)(int playerid, int objectid);
typedef int (*t_sampOnPlayerPickUpPickup)(int playerid, int pickupid);
typedef int (*t_sampOnPlayerPrivmsg)(int playerid, int recieverid, const char *text);
typedef int (*t_sampOnPlayerRequestClass)(int playerid, int classid);
typedef int (*t_sampOnPlayerRequestSpawn)(int playerid);
typedef int (*t_sampOnPlayerSelectedMenuRow)(int playerid, int row);
typedef int (*t_sampOnPlayerSpawn)(int playerid);
typedef int (*t_sampOnPlayerStateChange)(int playerid, int newstate, int oldstate);
typedef int (*t_sampOnPlayerText)(int playerid, const char *text);
typedef int (*t_sampOnRconCommand)(const char *cmd);
typedef int (*t_sampOnVehicleDeath)(int vehicleid, int killerid);
typedef int (*t_sampOnVehicleMod)(int vehicleid, int componentid);
typedef int (*t_sampOnVehiclePaintjob)(int vehicleid, int paintjobid);
typedef int (*t_sampOnVehicleRespray)(int vehicleid, int color1, int color2);
typedef int (*t_sampOnVehicleSpawn)(int vehicleid);

//-t_sampOnGameModeExit sampOnGameModeExit = NULL;
//-t_sampOnGameModeInit sampOnGameModeInit = NULL;

t_sampOnLoad sampOnLoad = NULL;
t_sampOnUnload sampOnUnload = NULL;

t_sampOnTimer100 sampOnTimer100 = NULL;

t_sampOnObjectMoved sampOnObjectMoved = NULL;
t_sampOnPlayerCommandText sampOnPlayerCommandText = NULL;
t_sampOnPlayerConnect sampOnPlayerConnect = NULL;
t_sampOnPlayerDeath sampOnPlayerDeath = NULL;
t_sampOnPlayerDisconnect sampOnPlayerDisconnect = NULL;
t_sampOnPlayerEnterCheckpoint sampOnPlayerEnterCheckpoint = NULL;
t_sampOnPlayerEnterRaceCheckpoint sampOnPlayerEnterRaceCheckpoint = NULL;
t_sampOnPlayerEnterVehicle sampOnPlayerEnterVehicle = NULL;
t_sampOnPlayerExitedMenu sampOnPlayerExitedMenu = NULL;
t_sampOnPlayerExitVehicle sampOnPlayerExitVehicle = NULL;
t_sampOnPlayerInfoChange sampOnPlayerInfoChange = NULL;
t_sampOnPlayerInteriorChange sampOnPlayerInteriorChange = NULL;
t_sampOnPlayerKeyStateChange sampOnPlayerKeyStateChange = NULL;
t_sampOnPlayerLeaveCheckpoint sampOnPlayerLeaveCheckpoint = NULL;
t_sampOnPlayerLeaveRaceCheckpoint sampOnPlayerLeaveRaceCheckpoint = NULL;
t_sampOnPlayerObjectMoved sampOnPlayerObjectMoved = NULL;
t_sampOnPlayerPickUpPickup sampOnPlayerPickUpPickup = NULL;
t_sampOnPlayerPrivmsg sampOnPlayerPrivmsg = NULL;
t_sampOnPlayerRequestClass sampOnPlayerRequestClass = NULL;
t_sampOnPlayerRequestSpawn sampOnPlayerRequestSpawn = NULL;
t_sampOnPlayerSelectedMenuRow sampOnPlayerSelectedMenuRow = NULL;
t_sampOnPlayerSpawn sampOnPlayerSpawn = NULL;
t_sampOnPlayerStateChange sampOnPlayerStateChange = NULL;
t_sampOnPlayerText sampOnPlayerText = NULL;
t_sampOnRconCommand sampOnRconCommand = NULL;
t_sampOnVehicleDeath sampOnVehicleDeath = NULL;
t_sampOnVehicleMod sampOnVehicleMod = NULL;
t_sampOnVehiclePaintjob sampOnVehiclePaintjob = NULL;
t_sampOnVehicleRespray sampOnVehicleRespray = NULL;
t_sampOnVehicleSpawn sampOnVehicleSpawn = NULL;

typedef void (*t_WrapperRegister)(const vector<SNamedFunction> amx_funcs, vector<SNamedFunction> &callback_funcs);

void *__zcoreFindNamedFunction(const vector<SNamedFunction> &funcs, const string &name)
{
	for(size_t i = 0; i < funcs.size(); i++)
	{
		if(funcs[i].name == name)
			return funcs[i].func;
	}

	string msg = "Unable to find callback function:\r\n";
	msg += name;
	MessageBoxA(0, msg.c_str(), "Error", 0);

	return NULL;
}

bool __zcoreGamemodeChanged(void)
{
	static FILETIME last_write_time = {0, 0};
	
	WIN32_FILE_ATTRIBUTE_DATA fad;

	if(!GetFileAttributesExA("plugins\\gamemode.dll", GetFileExInfoStandard, &fad))
		return false;

	if(last_write_time.dwHighDateTime != fad.ftLastWriteTime.dwHighDateTime
		|| last_write_time.dwLowDateTime != fad.ftLastWriteTime.dwLowDateTime)
	{
		last_write_time = fad.ftLastWriteTime;
		return true;
	}

	return false;
}

bool __zcoreLoadGamemode(void)
{
	logprintf("zcore: Loading gamemode...");

	if(ghGamemode)
		__zcoreUnloadGamemode();

	// -- Try to open dll file with exclusive rights (is it locked?) --

	HANDLE hFile = CreateFileA("plugins\\gamemode.dll", FILE_ALL_ACCESS,
		0,//no sharing
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if(hFile == INVALID_HANDLE_VALUE)
	{
		logprintf("zcore: Unable to open gamemode.dll with exclusive rights");
		Sleep(1000);//Allow the compiler to refresh the file
		return false;
	}
	else
		CloseHandle(hFile);

	// -- Copy the dll to a new location to load it then --

	if(CopyFileA("plugins\\gamemode.dll", "plugins\\gamemode.module", false) == 0)
	{
		logprintf("zcore: Unable to copy gamemode.dll to gamemode.module");
		return false;
	}

	ghGamemode = LoadLibraryA("plugins\\gamemode.module");

	DWORD err = GetLastError();

	if(!ghGamemode)
	{
		logprintf("zcore: Unable to load gamemode.module");
		return false;
	}

	t_WrapperRegister WrapperRegister = (t_WrapperRegister)GetProcAddress(ghGamemode, "WrapperRegister");

	if(!WrapperRegister)
	{
		//MessageBoxA(0, "Unable to get WrapperRegister() address.", "Error", 0);
		__zcoreUnloadGamemode();
		return false;
	}

	vector<SNamedFunction> amx_funcs;
	SNamedFunction f;

	f.name = "sampAddPlayerClass";
	f.func = sampAddPlayerClass;
	amx_funcs.push_back(f);

	f.name = "sampAllowAdminTeleport";
	f.func = sampAllowAdminTeleport;
	amx_funcs.push_back(f);

	f.name = "sampAllowInteriorWeapons";
	f.func = sampAllowInteriorWeapons;
	amx_funcs.push_back(f);

	f.name = "sampBan";
	f.func = sampBan;
	amx_funcs.push_back(f);

	f.name = "sampBanEx";
	f.func = sampBanEx;
	amx_funcs.push_back(f);

	f.name = "sampCreateExplosion";
	f.func = sampCreateExplosion;
	amx_funcs.push_back(f);

	f.name = "sampCreatePickup";
	f.func = sampCreatePickup;
	amx_funcs.push_back(f);

	f.name = "sampDestroyPickup";
	f.func = sampDestroyPickup;
	amx_funcs.push_back(f);

	f.name = "sampEnableTirePopping";
	f.func = sampEnableTirePopping;
	amx_funcs.push_back(f);

	f.name = "sampEnableZoneNames";
	f.func = sampEnableZoneNames;
	amx_funcs.push_back(f);

	f.name = "sampGameTextForAll";
	f.func = sampGameTextForAll;
	amx_funcs.push_back(f);

	f.name = "sampGameTextForPlayer";
	f.func = sampGameTextForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneCreate";
	f.func = sampGangZoneCreate;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneDestroy";
	f.func = sampGangZoneDestroy;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneFlashForAll";
	f.func = sampGangZoneFlashForAll;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneFlashForPlayer";
	f.func = sampGangZoneFlashForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneHideForAll";
	f.func = sampGangZoneHideForAll;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneHideForPlayer";
	f.func = sampGangZoneHideForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneShowForAll";
	f.func = sampGangZoneShowForAll;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneShowForPlayer";
	f.func = sampGangZoneShowForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneStopFlashForAll";
	f.func = sampGangZoneStopFlashForAll;
	amx_funcs.push_back(f);

	f.name = "sampGangZoneStopFlashForPlayer";
	f.func = sampGangZoneStopFlashForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampIsPlayerAdmin";
	f.func = sampIsPlayerAdmin;
	amx_funcs.push_back(f);

	f.name = "sampKick";
	f.func = sampKick;
	amx_funcs.push_back(f);

	f.name = "sampLimitGlobalChatRadius";
	f.func = sampLimitGlobalChatRadius;
	amx_funcs.push_back(f);

	f.name = "sampSendClientMessage";
	f.func = sampSendClientMessage;
	amx_funcs.push_back(f);

	f.name = "sampSendClientMessageToAll";
	f.func = sampSendClientMessageToAll;
	amx_funcs.push_back(f);

	f.name = "sampSendDeathMessage";
	f.func = sampSendDeathMessage;
	amx_funcs.push_back(f);

	f.name = "sampSendPlayerMessageToAll";
	f.func = sampSendPlayerMessageToAll;
	amx_funcs.push_back(f);

	f.name = "sampSendPlayerMessageToPlayer";
	f.func = sampSendPlayerMessageToPlayer;
	amx_funcs.push_back(f);

	f.name = "sampSetGameModeText";
	f.func = sampSetGameModeText;
	amx_funcs.push_back(f);

	f.name = "sampSetGravity";
	f.func = sampSetGravity;
	amx_funcs.push_back(f);

	f.name = "sampSetWeather";
	f.func = sampSetWeather;
	amx_funcs.push_back(f);

	f.name = "sampSetWorldTime";
	f.func = sampSetWorldTime;
	amx_funcs.push_back(f);

	f.name = "sampShowNameTags";
	f.func = sampShowNameTags;
	amx_funcs.push_back(f);

	f.name = "sampShowPlayerMarkers";
	f.func = sampShowPlayerMarkers;
	amx_funcs.push_back(f);

	f.name = "sampUsePlayerPedAnims";
	f.func = sampUsePlayerPedAnims;
	amx_funcs.push_back(f);

	// ---

	f.name = "sampAllowPlayerTeleport";
	f.func = sampAllowPlayerTeleport;
	amx_funcs.push_back(f);

	f.name = "sampApplyAnimation";
	f.func = sampApplyAnimation;
	amx_funcs.push_back(f);

	f.name = "sampClearAnimations";
	f.func = sampClearAnimations;
	amx_funcs.push_back(f);

	f.name = "sampDisablePlayerCheckpoint";
	f.func = sampDisablePlayerCheckpoint;
	amx_funcs.push_back(f);

	f.name = "sampDisablePlayerRaceCheckpoint";
	f.func = sampDisablePlayerRaceCheckpoint;
	amx_funcs.push_back(f);

	f.name = "sampForceClassSelection";
	f.func = sampForceClassSelection;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerAmmo";
	f.func = sampGetPlayerAmmo;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerArmour";
	f.func = sampGetPlayerArmour;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerColor";
	f.func = sampGetPlayerColor;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerFacingAngle";
	f.func = sampGetPlayerFacingAngle;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerHealth";
	f.func = sampGetPlayerHealth;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerInterior";
	f.func = sampGetPlayerInterior;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerIp";
	f.func = sampGetPlayerIp;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerKeys";
	f.func = sampGetPlayerKeys;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerMoney";
	f.func = sampGetPlayerMoney;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerName";
	f.func = sampGetPlayerName;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerPing";
	f.func = sampGetPlayerPing;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerPos";
	f.func = sampGetPlayerPos;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerScore";
	f.func = sampGetPlayerScore;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerSkin";
	f.func = sampGetPlayerSkin;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerSpecialAction";
	f.func = sampGetPlayerSpecialAction;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerState";
	f.func = sampGetPlayerState;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerTeam";
	f.func = sampGetPlayerTeam;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerTime";
	f.func = sampGetPlayerTime;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerVehicleID";
	f.func = sampGetPlayerVehicleID;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerVirtualWorld";
	f.func = sampGetPlayerVirtualWorld;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerWantedLevel";
	f.func = sampGetPlayerWantedLevel;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerWeapon";
	f.func = sampGetPlayerWeapon;
	amx_funcs.push_back(f);

	f.name = "sampGetPlayerWeaponData";
	f.func = sampGetPlayerWeaponData;
	amx_funcs.push_back(f);

	f.name = "sampGivePlayerMoney";
	f.func = sampGivePlayerMoney;
	amx_funcs.push_back(f);

	f.name = "sampGivePlayerWeapon";
	f.func = sampGivePlayerWeapon;
	amx_funcs.push_back(f);

	f.name = "sampIsPlayerConnected";
	f.func = sampIsPlayerConnected;
	amx_funcs.push_back(f);

	f.name = "sampIsPlayerInAnyVehicle";
	f.func = sampIsPlayerInAnyVehicle;
	amx_funcs.push_back(f);

	f.name = "sampIsPlayerInCheckpoint";
	f.func = sampIsPlayerInCheckpoint;
	amx_funcs.push_back(f);

	f.name = "sampIsPlayerInRaceCheckpoint";
	f.func = sampIsPlayerInRaceCheckpoint;
	amx_funcs.push_back(f);

	f.name = "sampIsPlayerInVehicle";
	f.func = sampIsPlayerInVehicle;
	amx_funcs.push_back(f);

	f.name = "sampPlayerPlaySound";
	f.func = sampPlayerPlaySound;
	amx_funcs.push_back(f);

	f.name = "sampPlayerSpectatePlayer";
	f.func = sampPlayerSpectatePlayer;
	amx_funcs.push_back(f);

	f.name = "sampPlayerSpectateVehicle";
	f.func = sampPlayerSpectateVehicle;
	amx_funcs.push_back(f);

	f.name = "sampPutPlayerInVehicle";
	f.func = sampPutPlayerInVehicle;
	amx_funcs.push_back(f);

	f.name = "sampRemovePlayerFromVehicle";
	f.func = sampRemovePlayerFromVehicle;
	amx_funcs.push_back(f);

	f.name = "sampRemovePlayerMapIcon";
	f.func = sampRemovePlayerMapIcon;
	amx_funcs.push_back(f);

	f.name = "sampResetPlayerMoney";
	f.func = sampResetPlayerMoney;
	amx_funcs.push_back(f);

	f.name = "sampResetPlayerWeapons";
	f.func = sampResetPlayerWeapons;
	amx_funcs.push_back(f);

	f.name = "sampSetCameraBehindPlayer";
	f.func = sampSetCameraBehindPlayer;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerAmmo";
	f.func = sampSetPlayerAmmo;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerArmour";
	f.func = sampSetPlayerArmour;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerCameraLookAt";
	f.func = sampSetPlayerCameraLookAt;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerCameraPos";
	f.func = sampSetPlayerCameraPos;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerCheckpoint";
	f.func = sampSetPlayerCheckpoint;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerColor";
	f.func = sampSetPlayerColor;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerFacingAngle";
	f.func = sampSetPlayerFacingAngle;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerHealth";
	f.func = sampSetPlayerHealth;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerInterior";
	f.func = sampSetPlayerInterior;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerMapIcon";
	f.func = sampSetPlayerMapIcon;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerMarkerForPlayer";
	f.func = sampSetPlayerMarkerForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerName";
	f.func = sampSetPlayerName;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerPos";
	f.func = sampSetPlayerPos;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerPosFindZ";
	f.func = sampSetPlayerPosFindZ;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerRaceCheckpoint";
	f.func = sampSetPlayerRaceCheckpoint;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerScore";
	f.func = sampSetPlayerScore;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerSkin";
	f.func = sampSetPlayerSkin;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerSpecialAction";
	f.func = sampSetPlayerSpecialAction;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerTeam";
	f.func = sampSetPlayerTeam;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerTime";
	f.func = sampSetPlayerTime;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerVirtualWorld";
	f.func = sampSetPlayerVirtualWorld;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerWantedLevel";
	f.func = sampSetPlayerWantedLevel;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerWeather";
	f.func = sampSetPlayerWeather;
	amx_funcs.push_back(f);

	f.name = "sampSetPlayerWorldBounds";
	f.func = sampSetPlayerWorldBounds;
	amx_funcs.push_back(f);

	f.name = "sampSetSpawnInfo";
	f.func = sampSetSpawnInfo;
	amx_funcs.push_back(f);

	f.name = "sampShowPlayerNameTagForPlayer";
	f.func = sampShowPlayerNameTagForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampSpawnPlayer";
	f.func = sampSpawnPlayer;
	amx_funcs.push_back(f);

	f.name = "sampTogglePlayerClock";
	f.func = sampTogglePlayerClock;
	amx_funcs.push_back(f);

	f.name = "sampTogglePlayerControllable";
	f.func = sampTogglePlayerControllable;
	amx_funcs.push_back(f);

	f.name = "sampTogglePlayerSpectating";
	f.func = sampTogglePlayerSpectating;
	amx_funcs.push_back(f);

	// ---

	f.name = "sampAddVehicleComponent";
	f.func = sampAddVehicleComponent;
	amx_funcs.push_back(f);

	f.name = "sampAttachTrailerToVehicle";
	f.func = sampAttachTrailerToVehicle;
	amx_funcs.push_back(f);

	f.name = "sampChangeVehicleColor";
	f.func = sampChangeVehicleColor;
	amx_funcs.push_back(f);

	f.name = "sampChangeVehiclePaintjob";
	f.func = sampChangeVehiclePaintjob;
	amx_funcs.push_back(f);

	f.name = "sampCreateVehicle";
	f.func = sampCreateVehicle;
	amx_funcs.push_back(f);

	f.name = "sampDestroyVehicle";
	f.func = sampDestroyVehicle;
	amx_funcs.push_back(f);

	f.name = "sampDetachTrailerFromVehicle";
	f.func = sampDetachTrailerFromVehicle;
	amx_funcs.push_back(f);

	f.name = "sampGetVehicleHealth";
	f.func = sampGetVehicleHealth;
	amx_funcs.push_back(f);

	f.name = "sampGetVehicleModel";
	f.func = sampGetVehicleModel;
	amx_funcs.push_back(f);

	f.name = "sampGetVehiclePos";
	f.func = sampGetVehiclePos;
	amx_funcs.push_back(f);

	f.name = "sampGetVehicleTrailer";
	f.func = sampGetVehicleTrailer;
	amx_funcs.push_back(f);

	f.name = "sampGetVehicleVirtualWorld";
	f.func = sampGetVehicleVirtualWorld;
	amx_funcs.push_back(f);

	f.name = "sampGetVehicleZAngle";
	f.func = sampGetVehicleZAngle;
	amx_funcs.push_back(f);

	f.name = "sampIsTrailerAttachedToVehicle";
	f.func = sampIsTrailerAttachedToVehicle;
	amx_funcs.push_back(f);

	f.name = "sampLinkVehicleToInterior";
	f.func = sampLinkVehicleToInterior;
	amx_funcs.push_back(f);

	f.name = "sampRemoveVehicleComponent";
	f.func = sampRemoveVehicleComponent;
	amx_funcs.push_back(f);

	f.name = "sampSetVehicleHealth";
	f.func = sampSetVehicleHealth;
	amx_funcs.push_back(f);

	f.name = "sampSetVehicleNumberPlate";
	f.func = sampSetVehicleNumberPlate;
	amx_funcs.push_back(f);

	f.name = "sampSetVehicleParamsForPlayer";
	f.func = sampSetVehicleParamsForPlayer;
	amx_funcs.push_back(f);

	f.name = "sampSetVehiclePos";
	f.func = sampSetVehiclePos;
	amx_funcs.push_back(f);

	f.name = "sampSetVehicleToRespawn";
	f.func = sampSetVehicleToRespawn;
	amx_funcs.push_back(f);

	f.name = "sampSetVehicleVirtualWorld";
	f.func = sampSetVehicleVirtualWorld;
	amx_funcs.push_back(f);

	f.name = "sampSetVehicleZAngle";
	f.func = sampSetVehicleZAngle;
	amx_funcs.push_back(f);

	vector<SNamedFunction> callback_funcs;

	WrapperRegister(amx_funcs, callback_funcs);

	sampOnLoad = (t_sampOnLoad)__zcoreFindNamedFunction(callback_funcs, "sampOnLoad");
	sampOnUnload = (t_sampOnUnload)__zcoreFindNamedFunction(callback_funcs, "sampOnUnload");

	sampOnTimer100 = (t_sampOnTimer100)__zcoreFindNamedFunction(callback_funcs, "sampOnTimer100");
	
	sampOnObjectMoved = (t_sampOnObjectMoved)__zcoreFindNamedFunction(callback_funcs, "sampOnObjectMoved");
	sampOnPlayerCommandText = (t_sampOnPlayerCommandText)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerCommandText");
	sampOnPlayerConnect = (t_sampOnPlayerConnect)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerConnect");
	sampOnPlayerDeath = (t_sampOnPlayerDeath)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerDeath");
	sampOnPlayerDisconnect = (t_sampOnPlayerDisconnect)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerDisconnect");
	sampOnPlayerEnterCheckpoint = (t_sampOnPlayerEnterCheckpoint)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerEnterCheckpoint");
	sampOnPlayerEnterRaceCheckpoint = (t_sampOnPlayerEnterRaceCheckpoint)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerEnterRaceCheckpoint");
	sampOnPlayerEnterVehicle = (t_sampOnPlayerEnterVehicle)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerEnterVehicle");
	sampOnPlayerExitedMenu = (t_sampOnPlayerExitedMenu)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerExitedMenu");
	sampOnPlayerExitVehicle = (t_sampOnPlayerExitVehicle)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerExitVehicle");
	sampOnPlayerInfoChange = (t_sampOnPlayerInfoChange)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerInfoChange");
	sampOnPlayerInteriorChange = (t_sampOnPlayerInteriorChange)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerInteriorChange");
	sampOnPlayerKeyStateChange = (t_sampOnPlayerKeyStateChange)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerKeyStateChange");
	sampOnPlayerLeaveCheckpoint = (t_sampOnPlayerLeaveCheckpoint)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerLeaveCheckpoint");
	sampOnPlayerLeaveRaceCheckpoint = (t_sampOnPlayerLeaveRaceCheckpoint)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerLeaveRaceCheckpoint");
	sampOnPlayerObjectMoved = (t_sampOnPlayerObjectMoved)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerObjectMoved");
	sampOnPlayerPickUpPickup = (t_sampOnPlayerPickUpPickup)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerPickUpPickup");
	sampOnPlayerPrivmsg = (t_sampOnPlayerPrivmsg)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerPrivmsg");
	sampOnPlayerRequestClass = (t_sampOnPlayerRequestClass)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerRequestClass");
	sampOnPlayerRequestSpawn = (t_sampOnPlayerRequestSpawn)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerRequestSpawn");
	sampOnPlayerSelectedMenuRow = (t_sampOnPlayerSelectedMenuRow)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerSelectedMenuRow");
	sampOnPlayerSpawn = (t_sampOnPlayerSpawn)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerSpawn");
	sampOnPlayerStateChange = (t_sampOnPlayerStateChange)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerStateChange");
	sampOnPlayerText = (t_sampOnPlayerText)__zcoreFindNamedFunction(callback_funcs, "sampOnPlayerText");
	sampOnRconCommand = (t_sampOnRconCommand)__zcoreFindNamedFunction(callback_funcs, "sampOnRconCommand");
	sampOnVehicleDeath = (t_sampOnVehicleDeath)__zcoreFindNamedFunction(callback_funcs, "sampOnVehicleDeath");
	sampOnVehicleMod = (t_sampOnVehicleMod)__zcoreFindNamedFunction(callback_funcs, "sampOnVehicleMod");
	sampOnVehiclePaintjob = (t_sampOnVehiclePaintjob)__zcoreFindNamedFunction(callback_funcs, "sampOnVehiclePaintjob");
	sampOnVehicleRespray = (t_sampOnVehicleRespray)__zcoreFindNamedFunction(callback_funcs, "sampOnVehicleRespray");
	sampOnVehicleSpawn = (t_sampOnVehicleSpawn)__zcoreFindNamedFunction(callback_funcs, "sampOnVehicleSpawn");

	bGamemodeLoaded = true;

	sampOnLoad();

	logprintf("zcore: Gamemode loaded");

	return true;
}

void __zcoreUnloadGamemode(void)
{
	logprintf("zcore: Unloading gamemode...");

	if(!ghGamemode)
		return;

	if(bGamemodeLoaded)
		sampOnUnload();
	
	bGamemodeLoaded = false;

	FreeLibrary(ghGamemode);
	ghGamemode = 0;

	sampOnObjectMoved = NULL;
	sampOnPlayerCommandText = NULL;
	sampOnPlayerConnect = NULL;
	sampOnPlayerDeath = NULL;
	sampOnPlayerDisconnect = NULL;
	sampOnPlayerEnterCheckpoint = NULL;
	sampOnPlayerEnterRaceCheckpoint = NULL;
	sampOnPlayerEnterVehicle = NULL;
	sampOnPlayerExitedMenu = NULL;
	sampOnPlayerExitVehicle = NULL;
	sampOnPlayerInfoChange = NULL;
	sampOnPlayerInteriorChange = NULL;
	sampOnPlayerKeyStateChange = NULL;
	sampOnPlayerLeaveCheckpoint = NULL;
	sampOnPlayerLeaveRaceCheckpoint = NULL;
	sampOnPlayerObjectMoved = NULL;
	sampOnPlayerPickUpPickup = NULL;
	sampOnPlayerPrivmsg = NULL;
	sampOnPlayerRequestClass = NULL;
	sampOnPlayerRequestSpawn = NULL;
	sampOnPlayerSelectedMenuRow = NULL;
	sampOnPlayerSpawn = NULL;
	sampOnPlayerStateChange = NULL;
	sampOnPlayerText = NULL;
	sampOnRconCommand = NULL;
	sampOnVehicleDeath = NULL;
	sampOnVehicleMod = NULL;
	sampOnVehiclePaintjob = NULL;
	sampOnVehicleRespray = NULL;
	sampOnVehicleSpawn = NULL;
	
	logprintf("zcore: Gamemode unloaded");
}

void __zcoreShutdown(void)
{
	__zcoreUnloadGamemode();
	Sleep(500);//NOTE: just to see how it exits in console
}

void __zcoreException(void)
{
	__zcoreUnloadGamemode();
	__zcoreLoadGamemode();
}
